<?php

if (!defined('SMF'))
	die('Hacking attempt...');
	
/*

	Blog Community 2.0.2 Beta
	
	Blog Community was developed by Charles Hill for use in conjunction with Simple Machines Forum.  The 
	code of Blog Community is not to be redistributed or used for any purpose other than what is intended 
	without express written permission from the developer.  All rights are reserved by the developer.
	
	This software is distributed in the hope that it is and will be useful, but WITHOUT ANY WARRANTIES; without even 
	any implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
	
*/

function blog_theme_above()
{
	global $context, $settings, $options, $scripturl, $txt, $language, $modSettings;

	echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"', $context['right_to_left'] ? ' dir="rtl"' : '', '>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=', $context['character_set'], '" />
<meta name="description" content="' . (!empty($context['blog']['meta']['description']) ? $context['blog']['meta']['description'] : $context['page_title']) . '" />
' . (empty($context['robot_no_index']) ? '' : '<meta name="robots" content="noindex" />') . '
<meta name="keywords" content="' . (!empty($context['blog']['meta']['keywords']) ? $context['blog']['meta']['keywords'] : 'community blogging smf') . '" />
<script language="JavaScript" type="text/javascript" src="', $settings['default_theme_url'], '/script.js?fin11"></script>';
	
	echo '
<script language="JavaScript" type="text/javascript"><!-- // --><![CDATA[
	var smf_theme_url = "', $settings['theme_url'], '";
	var smf_images_url = "', $settings['images_url'], '";
	var smf_scripturl = "', $scripturl, '";
	var smf_iso_case_folding = ', $context['server']['iso_case_folding'] ? 'true' : 'false', ';
	var smf_charset = "', $context['character_set'], '";
// ]]></script>
<title>', $context['page_title'], '</title>';
//$context['blog_theme_url']
	// The ?finll part of this link is just here to make sure browsers don't cache it wrongly.
 	echo '
<link rel="stylesheet" type="text/css" href="', $settings['theme_url'], '/style.css?fin11" />
<link rel="stylesheet" type="text/css" href="', $settings['default_theme_url'], '/print.css?fin11" media="print" />

<!--[if lte IE 6]>
	<link rel="stylesheet" type="text/css" href="', $settings['theme_url'], '/ie6lte.css?fin11" />
<![endif]-->';
	
	/* Internet Explorer 4/5 and Opera 6 just don't do font sizes properly. (they are big...)
		Thus, in Internet Explorer 4, 5, and Opera 6 this will show fonts one size smaller than usual.
		Note that this is affected by whether IE 6 is in standards compliance mode.. if not, it will also be big.
		Standards compliance mode happens when you use xhtml... */
	if ($context['browser']['needs_size_fix'])
		echo '
<link rel="stylesheet" type="text/css" href="', $settings['theme_url'], '/fonts-compat.css" />';
	elseif ($context['browser']['is_ie'])
		echo '
<link rel="stylesheet" type="text/css" href="', $settings['theme_url'], '/fonts-compat.css" />';

	// Show all the relative links, such as help, search, contents, and the like.
	echo '
<link rel="help" href="', $scripturl, '?action=help" target="_blank" />
<link rel="search" href="' . $scripturl . '?action=search" />
<link rel="contents" href="', $scripturl, '" />';

	// if we're viewing a article in a BLOG, these should be the previous and next topics, respectively.
	if (!empty($context['current_article']))
		echo '
<link rel="prev" href="', $scripturl, '?article=', $context['current_article'], '.0;prev_next=prev" />
<link rel="next" href="', $scripturl, '?article=', $context['current_article'], '.0;prev_next=next" />';

	// If we're in a board, or a topic for that matter, the index will be the board's index.
	if (!empty($context['current_blog']))
		echo '
<link rel="index" href="' . $scripturl . '?blog=' . $context['current_blog'] . '.0" />';

	// If RSS feeds are enabled, advertise the presence of one.
	if (!empty($modSettings['xmlnews_enable']) && !empty($context['current_blog']))
		echo '
<link rel="alternate" type="application/rss+xml" title="'. $context['blog_name'] .' - RSS" href="' . $scripturl . '?action=.xml;board='. $context['current_blog'] .';type=rss" />';
	
	// PNG fix for IE < 7
	if ($context['browser']['is_ie'] && !$context['browser']['is_ie7'])
		echo '
<script defer type="text/javascript" src="', $settings['default_theme_url'], '/pngfix.js"></script>';

	echo '
</head>
<body>
<table border="0" cellspacing="0" cellpadding="0" width="', $context['blog']['container_width'] ,'" align="', $context['blog']['container_alignment'] ,'">
	<tr>
		<td id="left_container"></td>
		<td align="', $context['blog']['container_alignment'] ,'" id="center_container">';
}

function blog_theme_below()
{
	global $txt, $context;
	
	echo '
	<br />
	<div class="copyright" style="text-align:center; line-height:140%;" id="blogCopyRight">';
	
	// do not mess with this ... please :)
	blogcopyright('fb3773bdd88f0e6fd6bec61d6f16ea1694c2850b,3de43f42db8cda0573610c4385f9e41d40fdc39d,24aa6ae9afdcea2874b966cd13d3afa1b22879cc,e013735e4643cb54ce5aafd0fd367a4679ac6d0c');
	
	echo '<br />', theme_copyright();
	
	if ($context['show_load_time'])
		echo '<br />' . $txt['smf301'] . $context['load_time'] . $txt['smf302'] . $context['load_queries'] . $txt['smf302b'];
	
	echo '
	</div>';

	if (empty($context['bcr']))
		echo '
	<div style="bottom:4px;text-align:center;position:'. ($context['browser']['is_ie'] && !$context['browser']['is_ie7'] ? 'absolute' : '') .';z-index:500;">'. $txt['b348'] .'</div>';
	
	echo '
	<br />
	
			</td>
			<td id="right_container"></td>
		</tr>
	</table>
</body>
</html>';
}

function template_main()
{
	global $settings, $modSettings, $context, $txt, $scripturl, $blog;
	
	// let's figure out some stuff here so it's cleaner down below
	if (empty($context['viewing_blog_index']) && !empty($blog))
	{
		// first check if we want to show the side windows at all
		if (empty($context['blog']['settings']['hide_side_windows']) && !empty($context['blog']['sideWindowContent']) && (!empty($context['blog']['articles']) || !empty($context['blog']['list_of_articles'])))
		{
			// show the side bar on the left?
			if (!empty($context['blog']['settings']['justifySideWindows']))
				$blog_page_side_bar_left = true;
			// show it on the right maybe?
			elseif (empty($context['blog']['settings']['justifySideWindows']))
				$blog_page_side_bar_right = true;
		}
	
		// number of columns in sub-containing table
		$numColumns = !empty($blog_page_side_bar_right) || !empty($blog_page_side_bar_left) ? 2 : 1;
		
		// show without forum layers?  We will need to use our own above and below layers
		$not_using_forum_layers = !empty($context['blog']['settings']['pseudoIndependent']) || !empty($modSettings['toggle_all_layerless']);
	}
	else
	{
		// first see if we want to show the blog index side bar at all
		if (!empty($modSettings['blog_index_side_bar']) && !empty($context['blog']['sideWindowContent']))
		{
			// show it on the left?
			if ($modSettings['blog_index_side_bar'] == 1)
				$blog_index_side_bar_left = true;
			// show it on the right?
			elseif ($modSettings['blog_index_side_bar'] == 2)
				$blog_index_side_bar_right = true;
		}
	
		// number of columns in sub-containing table
		$numColumns = !empty($modSettings['blog_index_side_bar']) && !empty($context['blog']['sideWindowContent']) ? 2 : 1;
		
		// show without forum layers?  We will need to use our own above and below layers
		$not_using_forum_layers = !empty($modSettings['blog_index_without_layers']) || !empty($modSettings['toggle_all_layerless']);
	}
	
	/*          Do NOT echo anything above this line             */
	/*  -------------------------------------------------------- */
	
	if ($not_using_forum_layers)
		blog_theme_above();

	// start main/sub-containing table
	echo '
	<table border="0" cellpadding="0" cellspacing="0" width="100%">';
	
	// link tree and extra links
	if (!empty($context['blog']['link_tree']) || !empty($context['blog']['extra_links']))
	{
		echo '
		<tr>
			<td colspan="', $numColumns, '" valign="top" width="100%" id="top">';
				blog_link_tree();
		echo '
			</td>
		</tr>';
	}
	
	//  previous, next, and go bottom links
	if ((!empty($context['previous_link']) && !empty($context['next_link'])) || !empty($context['go_bottom_link']))
		echo '
		<tr class="needsPadding">
			<td colspan="', $numColumns, '" valign="middle" width="100%">
				<table border="0" cellpadding="0" cellspacing="0" width="100%">
					<tr class="noPadding">
						<td align="left">', !empty($context['previous_link']) ? $context['previous_link'] : '', '</td>
						<td align="center">', !empty($context['go_bottom_link']) ? $context['go_bottom_link'] : '', '</td>
						<td align="right">', !empty($context['next_link']) ? $context['next_link'] : '', '</td>
					</tr>
				</table>
			</td>
		</tr>';
		
	// start main row of containing table
	echo'
		<tr>';
	
	// side bar if it's on the left
	if (!empty($blog_page_side_bar_left) || !empty($blog_index_side_bar_left))
	{
		echo '
			<td valign="top" width="22%" align="center" style="padding-right:8px;">';
				
				template_sideWindow($context['blog']['sideWindowContent']);
		
				template_extraBelowSideWindows();
		
		echo '
			</td>';
	}
		
	echo '
			<td valign="top"', (!empty($blog_page_side_bar_left) || !empty($blog_page_side_bar_right) || !empty($blog_index_side_bar_left) || !empty($blog_index_side_bar_right)) ? ' width="78%"' : '', '>';
			
	// if there was an error... display it
	if (!empty($context['blog']['blogError']))
		template_showError();
	// viewing an article or articles?... show them
	elseif (!empty($context['blog']['articles']))
		template_showArticles();
	// viewing a list of articles?
	elseif (!empty($context['blog']['list_of_articles']))
		template_showListOfArticles();
	// fall through to the blog index
	elseif (!empty($context['viewing_blog_index']))
		template_BlogIndex();
	
	echo '
			</td>';
	
	// side bar if it's on the right
	if (!empty($blog_page_side_bar_right) || !empty($blog_index_side_bar_right))
	{
		echo '
			<td valign="top" width="22%" align="center" style="padding-left:8px;">';
		
				template_sideWindow($context['blog']['sideWindowContent']);
		
				template_extraBelowSideWindows();
		
		echo '
			</td>';
	}
	
	echo '
		</tr>';
	
	//  previous, next, and go up links
	if ((!empty($context['previous_link']) && !empty($context['next_link'])) || !empty($context['go_top_link']))
		echo '
		<tr class="needsPadding">
			<td colspan="', $numColumns, '" valign="middle" width="100%">
				<table border="0" cellpadding="0" cellspacing="0" width="100%">
					<tr class="noPadding">
						<td align="left">', !empty($context['previous_link']) ? $context['previous_link'] : '', '</td>
						<td align="center">', !empty($context['go_top_link']) ? $context['go_top_link'] : '', '</td>
						<td align="right">', !empty($context['next_link']) ? $context['next_link'] : '', '</td>
					</tr>
				</table>
			</td>
		</tr>';
		
	echo '
	</table>';
	
	if ($not_using_forum_layers)
		blog_theme_below();
}


function blog_link_tree()
{
	global $context;
	echo '
	<br />
	<table width="100%" border="0" cellspacing="1" cellpadding="4" class="bordercolor">
		<tr>
			<td class="catbg" align="center">
				<span style="float:left;">';
							
		// spew the links from the blog link tree
		if (!empty($context['blog']['link_tree']))
			foreach ($context['blog']['link_tree'] as $key => $link)
			{
				if (!empty($key))
					echo $context['blog']['link_tree_divider'];
				echo $link;
			}
			
		echo '
				</span>
				<span style="float:right;">';
						
		// spew any extra links	
		if (!empty($context['blog']['extra_links']))
			foreach ($context['blog']['extra_links'] as $key => $link)
			{
				if (!empty($key))
					echo '&nbsp;-&nbsp;';	
				echo $link;
			}
		
		echo '
				</span>
			</td>
		</tr>
	</table>';
}


function template_showError()
{
	global $context;
	echo '
	<br />
	<table width="100%" border="0" cellspacing="1" cellpadding="0" class="bordercolor">
		<tr>
			<td align="center" class="windowbg2">
				<table width="100%" cellpadding="4" cellspacing="0" border="0">
					<tr>
						<td align="center">', $context['blog']['blogError'], '</td>
					</tr>
				</table>
			</td>
		</tr>
	</table>';
}



function template_showListOfArticles()
{
	global $context, $txt;
		
	// if $context['blog']['list_of_articles'] is an array that means it is a list of article info, so display it as such
	if (is_array($context['blog']['list_of_articles']))
	{
		echo '
	<br />
	<table width="100%" border="0" cellspacing="1" cellpadding="0" class="bordercolor"><tr><td width="100%">
	<table border="0" cellspacing="0" cellpadding="4" width="100%">
		<tr>
			<td valign="middle" class="catbg" align="center" colspan="5" width="100%">
				<span style="float:left;"></span>
				<span>'. $context['title'] .'</span>
				<span style="float:right;">'. (is_array($context['blog']['list_of_articles']) && !empty($context['show_page_index']) ? '<span style="font-weight:normal;">' . $txt['b63'] . ':</span> '. $context['page_index'] : '') .'</span>
			</td>
		</tr>
		<tr class="titlebg">
			<td align="left">'. $context['blog']['table_headers']['subject'] .'</td>
			<td align="center">'. $context['blog']['table_headers']['comments'] .'</td>
			<td align="center">'. $context['blog']['table_headers']['views'] .'</td>
			<td align="center">'. $context['blog']['table_headers']['author'] .'</td>
			<td align="right">'. $context['blog']['table_headers']['date'] .'</td>
		</tr>';
				
		$c = 0;
		foreach ($context['blog']['list_of_articles'] as $article)
		{
			$c++;
			echo '
		<tr class="windowbg', $c%2 ? '' : '2', '">
			<td align="left">'. $article['link'] .'</td>
			<td align="center">'. $article['replies'] .'</td>
			<td align="center">'. $article['views'] .'</td>
			<td align="center">'. $article['poster']['link'] .'</td>
			<td align="right">'. $article['time'] .'</td>
		</tr>';
		}
	}
	// if $context['blog']['list_of_articles'] is not an array, that means it is just an informative piece of text
	elseif (!is_array($context['blog']['list_of_articles']))
		echo '
		<tr class="windowbg2">
			<td colspan="5" align="center">'. $context['blog']['list_of_articles'] .'</td>
		</tr>';
		
	echo '
	</table>
	</td></tr></table>';
}


function template_showArticles()
{
	global $context, $scripturl, $txt, $settings, $blog;
	
	foreach ($context['blog']['articles'] as $article)
	{
		echo '
	<br />
	<table width="100%" border="0" cellspacing="1" cellpadding="0" class="bordercolor">
		<tr>
			<td align="center" class="windowbg2">
				<div style="padding:0;padding-left:12px; padding-right:12px;margin:0;">
				<table border="0" cellspacing="0" cellpadding="0" width="100%" id="b'. $article['message_id'] .'">
					<tr>
						<td valign="top" width="100%" align="left">
							<table border="0" cellspacing="0" cellpadding="0" width="100%" style="padding:0;margin:0;">
								<tr>
									<td colspan="2" width="100%" align="left" style="padding:6px; border-bottom:1px solid #BBBBBB; padding-left:0; padding-top:12px;"><h1 style="font-size:14px; font-weight:bold;">'. $article['link'] .'</h1>
									</td>
								</tr>
								<tr>
									<td valign="top" style="padding:4px;" width="100%">'. $txt['b40'] .' '. $article['poster']['link'] . ' ' . $txt[30] . ' ' . $article['time'] .'</td>
									<td rowspan="2" valign="top" style="padding:4px; padding-right:0;" align="right" width="60">';
									
		if (!empty($article['bookmarking_links']))
		{
			$margin_fix = (-41) + (count($article['bookmarking_links']) >= 2 ? ((count($article['bookmarking_links']) - 1) * 26) : 0);
			// don't ask questions... just know it works ;)
			$margin_fix = $margin_fix * (-1);
			echo '
										<div class="msgOptionsDropDown" style="white-space:nowrap; margin-bottom:3px; margin-top:3px; vertical-align:bottom;">
											<div class="displayOnHover" style="margin-top:-3px; margin-left:'. $margin_fix .'px;">
												'. implode('', $article['bookmarking_links']) .'
											</div>
											<div class="alwaysDisplay" style="width:60px;">'. $txt['b64'] .'</div>
										</div><br />';
		}
						
		//   Have a problem with IE7 and this pop-out menu?
		//		- check your index.template.php
		//		- make sure the DOCTYPE declaration doesn't have any tabs, spaces, or line breaks before it
		
			$margin_fix = -41;
			if ($article['can_modify'])
				$margin_fix = $margin_fix + 26;
			if ($article['can_remove'])
				$margin_fix = $margin_fix + 26;
			if ($article['can_lock_topic'] || $context['can_moderate_board'])
				$margin_fix = $margin_fix + 26;
			if ($context['can_send_topic'] || $context['can_moderate_board'])
				$margin_fix = $margin_fix + 30;
			if ($context['can_mark_notify'])
				$margin_fix = $margin_fix + 25;
				
			// don't ask questions... just know it works ;)
			$margin_fix = $margin_fix * (-1);
					
		echo '
										<div class="msgOptionsDropDown" style="white-space:nowrap; margin-top:3px;">
											<div class="displayOnHover" style="margin-left:'. $margin_fix .'px;">'. (!empty($article['options']) ? implode('', $article['options']) : '') .'</div>
											<div class="alwaysDisplay" style="width:60px;">'. $txt['b43'] .'</div>
										</div>';
										
		// plug-in slot #1
		if (!empty($context['blog']['plugin_slots'][1]))
			if (file_exists($sourcedir . '/BlogPlugins.php'))
			{
				require_once($sourcedir . '/BlogPlugins.php');
				if (function_exists('blogPluginSlot1'))
					blogPluginSlot1();
			}
			
		echo '
									</td>
								</tr>
								<tr>
									<td valign="top" width="100%" style="padding:4px; padding-top:8px;">'. $article['body'] .'</td>
									<td></td>
								</tr>';
									
		if (!empty($article['tags']) || !empty($article['category']))
			echo '
								<tr>
									<td valign="bottom" align="left" colspan="2" style="line-height:145%;padding-top:5px;padding-bottom:5px;">
										<table border="0" cellspacing="0" cellpadding="0" align="left">
										', !empty($article['tags']) ? '
											<tr>
												<td align="center">
													<img src="'. $settings['default_theme_url'] .'/images/icons/tag_icon.gif" title="'. $txt['b26a'] .'" alt="'. $txt['b26a'] .':" />
												</td>
												<td>&nbsp;' . implode(', ', $article['tags']) . '</td>
											</tr>' : '', '
										', !empty($article['category']) ? '
											<tr>
												<td align="center">
													<img src="'. $settings['default_theme_url'] .'/images/icons/CategoryIcon.gif" alt="'. $txt['b16'] .':" title="'. $txt['b16'] .'" />
												</td>
												<td>&nbsp;'. $article['category'] .'</td>
											</tr>' : '', '	
										</table>						
									</td>
								</tr>';
		echo '
							</table>
						</td>
					</tr>
				</table>';
	
		if (empty($context['blog']['settings']['hide_comments']) && (!empty($context['blog']['settings']['display_comments_blog']) || !empty($context['viewing_single_article'])))
			echo '
				<table border="0" width="100%" cellspacing="0" cellpadding="4">
					<tr class="commentsHeader">
						<td align="left">'. (!empty($article['comments']) && !empty($context['show_page_index']) ? '<span style="font-weight:normal;">' . $txt['b63'] . ':</span> ' . $context['page_index'] : '') .'</td>
						<td align="right">' . $article['replies'] . '&nbsp;' . ($article['replies'] == 1 ? $txt['b15'] : $txt['b15a']) . ($article['can_reply'] ? '&nbsp;<span style="font-size:14px;color:#C6C6C6;">|</span>&nbsp;'. $article['new_comment'] : '') .'</td>	
					</tr>
				</table><br />';

		if (!empty($article['comments']))
		{
			$c=0;
			foreach ($article['comments'] as $comment)
			{
				$c++;
				echo '
				<div style="padding-bottom:12px;">
				<table border="0" width="100%" cellspacing="1" cellpadding="4" id="b'. $comment['message_id'] .'" class="bordercolor">
					<tr class="windowbg', $c%2 ? '' : '2' ,'"><td width="100%">
						<table border="0" cellspacing="0" cellpadding="0" width="100%">
							<tr class="commentWrittenBy">
								<td valign="top" align="left" style="line-height:135%;" width="100%">'. $comment['body'] .'</td>
								<td valign="top" align="right" width="60">';
									
				//   Have a problem with IE7 and this pop-out menu?
				//		- check your index.template.php
				//		- make sure the DOCTYPE declaration doesn't have any tabs, spaces, or line breaks before it
				
				$margin_fix = -50;
				if ($comment['can_modify'])
					$margin_fix = $margin_fix + 20;
				if ($comment['can_remove'])
					$margin_fix = $margin_fix + 20;
				
				// don't ask questions... just know it works ;)
				$margin_fix = $margin_fix * (-1);
						
				if (!empty($comment['options']))			
					echo '
									<div class="msgOptionsDropDown">
										<div class="displayOnHover" style="margin-top:0; margin-left:'. $margin_fix .'px;">', implode('', $comment['options']), '</div>
										<div class="alwaysDisplay" style="width:60px;">'. $txt['b43'] .'</div>
									</div>';
							
				// comment requires approval alert (and its a link to approve the comment)
				if (!empty($context['blog']['settings']['comments_require_approval']) && empty($comment['is_approved']) && $comment['can_see_unapproved'])
					echo '
									<div class="unapprovedAlert">
										<a title="', $context['can_moderate_board'] ? $txt['click_to_approve'] . '" href="'. $scripturl .'?action=approveComment;blog='. $blog .';article=' . $article['id'] . ';comment='. $comment['message_id'] .';sesc='. $context['session_id'] .'"' : $txt['comment_awaiting_approval'] . '"', '>
											<img src="'. $settings['default_theme_url'] .'/images/icons/failure_icon.gif" alt="" />
										</a>
									</div>';
										
				// plug-in slot #2
				if (!empty($context['blog']['plugin_slots'][2]))
					if (file_exists($sourcedir . '/BlogPlugins.php'))
					{
						require_once($sourcedir . '/BlogPlugins.php');
						if (function_exists('blogPluginSlot2'))
							blogPluginSlot2();
					}
										
				echo '
								</td>
							</tr>
							<tr class="commentWrittenBy">
								<td align="left" valign="middle">'. $txt['b40'] .' ' . $comment['poster']['link'] . '<span class="commentSpecial">' . $txt[30] . ' ' . $comment['time'] .'</span></td>
								'. (empty($comment['modified']['name']) && !empty($comment['extra_links']) ? '
								<td align="right" valign="bottom" width="100" style="white-space:nowrap;">
									'. implode('', $comment['extra_links']) .'
								</td>' : '<td></td>') . '
							</tr>';
						
				if (!empty($comment['modified']['name']))
					echo '
							<tr class="commentSpecial">
								<td align="left" width="50%">
									<span class="lastEdit">&#171; <i>', $txt[211], ': ', $comment['modified']['time'], ' ', $txt[525], ' ', $comment['modified']['name'], '</i> &#187;</span>
								</td>
								', !empty($comment['extra_links']) ? '
								<td align="right" valign="bottom" width="80" style="white-space:nowrap;">'. implode('', $comment['extra_links']) .'</td>' : '<td></td>', '
							</tr>';
						
				echo '
						</table>
					</td></tr>
				</table>
				</div>';
			}
		}
		echo '
			</td>
		</tr>
	</table>';
	}
}



function template_sideWindow($array)
{
	global $context;
	// it's done this way for ordering purposes...
	for ($i = 1; $i <= count($context['blog']['sideWindows']); $i++)
	{
		if (!empty($array[$i]['info']))
		{
			echo '
	<br />
	<table width="100%" border="0" cellspacing="1" cellpadding="4" class="bordercolor">
		<tr>
			<td class="catbg" align="center">'. $array[$i]['title'] .'</td>
		</tr>
		<tr class="windowbg2">
			<td align="center">
				<table border="0" cellspacing="0" cellpadding="0" align="center">';
			
			// do we want to display the info as a simple list?
			if ($array[$i]['type'] == 'list')
			{
				foreach ($array[$i]['info'] as $info)
					echo '
					<tr><td align="center">', !empty($info['link']) ? $info['link'] : '', '</td></tr>';
			}
			// is this a stats window?
			elseif ($array[$i]['type'] == 'stats')
			{
				for ($m = 0; $m <= count($array[$i]['info']); $m++)
					if (!empty($array[$i]['info'][$m]))
						echo '
					<tr><td align="center">'. $array[$i]['info'][$m] .'</td></tr>';
			}
			// is this a tags window?
			elseif ($array[$i]['type'] == 'tags')
			{
				echo '
					<tr><td align="center">';
				foreach ($array[$i]['info'] as $key => $info)
				{
					if (!empty($key))
						echo ', ';
						
					echo $info['link'];
				}
				echo '
					</td></tr>';
			}
			// is this a custom window?
			elseif ($array[$i]['type'] == 'custom')
			{
				echo '
					<tr>
						<td align="center">
						'. $array[$i]['info'] .'
						</td>
					</tr>';
			}
			elseif ($array[$i]['type'] == 'polls')
			{
				
				echo '
					<tr class="needsLessPadding">
						<td align="center">';
				$c = false;
				foreach ($array[$i]['info'] as $poll)
				{
					if (!empty($c))
						echo '
							<hr class="hrcolor" size="1" width="80%" />';
					template_spewPoll($poll);
					$c = true;
				}
				echo '
						</td>
					</tr>';
			}
							
			echo '
				</table>
			</td>
		</tr>
	</table>';
		}
	}
}


function template_BlogIndex()
{
	global $txt, $context, $modSettings, $settings, $scripturl;
			
	$numColumns = 4;
	if (!empty($modSettings['showAvatarsOnBlogIndex']))
		$numColumns++;
	if (!empty($modSettings['xmlnews_enable']) && !empty($modSettings['showRSSFeedsOnBlogIndex']))
		$numColumns++;
			
	echo '
	<br />
	<table width="100%" border="0" cellspacing="1" cellpadding="0" class="bordercolor"><tr><td width="100%">
		<table border="0" cellspacing="0" cellpadding="4" width="100%">
			<tr class="catbg">
				<td valign="middle" align="center" colspan="', $numColumns, '" style="padding-right:4px; padding-left:4px;" width="100%">
					<span style="float:left;"></span>
					<span>'. $txt['blog_index'] .'</span>
					<span style="font-weight:normal; float:right;">', !empty($context['show_page_index']) ? $txt['b63'] . ':</span> '. $context['page_index'] : '', '
				</td>
			</tr>';
						
	if (!empty($context['blogs']))
	{
		echo '
			<tr class="titlebg">
				' . (!empty($modSettings['showAvatarsOnBlogIndex']) ? '<td width="60"></td>' : '') . '
				<td width="250"><div style="padding-left:15px;">'. $context['blog']['table_headers']['name'] .'</div></td>
				<td align="center" width="75">'. $context['blog']['table_headers']['posts'] .'</td>
				<td align="center" width="75">'. $context['blog']['table_headers']['views'] .'</td>
				<td width="250"><div style="padding-left:10px;">'. $context['blog']['table_headers']['last_post'] .'</div></td>
				'. (!empty($modSettings['xmlnews_enable']) && !empty($modSettings['showRSSFeedsOnBlogIndex']) ? '<td width="40"></td>' : '') .'
			</tr>';
		$c = 0;
		foreach ($context['blogs'] as $blog)
		{
			$c++;
			echo '
			<tr class="windowbg', $c%2 ? '' : '2' ,'">';
							
			if (!empty($modSettings['showAvatarsOnBlogIndex']))
				echo '
				<td width="60" valign="middle" align="center">
					', !empty($blog['owner']['avatar']) ? $blog['owner']['avatar'] : '', '
				</td>';
								
			echo '
				<td width="250" valign="middle">
					<table border="0" cellpadding="0" cellspacing="0" width="100%" style="padding-left:10px;">
						<tr class="noPadding">
							<td>'. $blog['link'] .'</td>
						</tr>
						', !empty($blog['description']) ? '
						<tr class="noPadding">
							<td style="white-space:normal;">'. $blog['description'] .'</td>
						</tr>' : '', '
					</table>
				</td>
				<td width="75" valign="middle" align="center" style="line-height:120%;">
					<span style="white-space:nowrap;">'. $blog['numArticles'] .' ', $blog['numArticles'] == 1 ? $txt['b66'] : $txt['b66a'], '</span><br />
					<span style="white-space:nowrap;">'. $blog['numComments'] .' ', $blog['numComments'] == 1 ? $txt['b15'] : $txt['b15a'], '</span>
				</td>
				<td width="75" valign="middle" align="center">
					<span style="white-space:nowrap;">'. $blog['blogViews'] .' ', $blog['blogViews'] == 1 ? $txt[305] : $txt[301], '</span>
				</td>
				<td width="250" valign="middle">';
				
			if (!empty($blog['last_post']['subject']))
				echo '
					<table border="0" cellpadding="0" cellspacing="0" width="100%" style="padding-left:10px;line-height:120%;">
						<tr class="noPadding">
							<td><b>'. $txt[22] . '</b> ' . $txt[525] . ' ', $blog['last_post']['poster']['link'], '</td>
						</tr>
						<tr class="noPadding">
							<td>'. $txt['smf88'] . ' ' . $blog['last_post']['link'] .'</td>
						</tr>
						<tr class="noPadding">
							<td> '. $txt[30] .' '. $blog['last_post']['posterTime'] .'</td>
						</tr>
					</table>';
					
			echo '
				</td>'. (!empty($modSettings['xmlnews_enable']) && !empty($modSettings['showRSSFeedsOnBlogIndex']) ? '
				<td valign="middle" width="40" align="center">
					<a href="' . $scripturl . '?action=.xml;board=' . $blog['id'] . ';type=rss" title="'. $txt['rss_feed'].'"><img src="'. $settings['default_theme_url'] .'/images/icons/medium_rss_icon.png" alt="rss" /></a>
				</td>' : '') .'
			</tr>';
		}
							
	}
	else
		echo '
			<tr class="windowbg"><td colspan="'. (!empty($modSettings['showAvatarsOnBlogIndex']) ? '6' : '5') .'">'. $txt['no_blogs'] .'</td></tr>';

	echo '
		</table>
	</td></tr></table>';		
}


function template_spewPoll($poll)
{
	global $context, $txt, $settings, $scripturl;
	// obviously need the question ;)
	echo '
							<div style="padding:5px; font-size:12px; text-align:center;">'. $poll['question'] .'</div>';
	// show expire time if there is one... or show if it is already expired
	if (!empty($poll['expire_time']))
		echo '
							<div style="padding:5px; font-size:9px; text-align:center;">(', ($poll['is_expired'] ? $txt['poll_expired_on'] : $txt['poll_expires_on']), ': ', $poll['expire_time'], ')</div>';
							
	echo '
							<div style="padding-bottom:6px;">';						
				
	// Are they not allowed to vote but allowed to view the options?
	if ($poll['show_results'] || !$poll['allow_vote'])
	{
		echo '
							<table>
								<tr class="needsPadding">
									<td style="padding-top: 1ex;">
										<table border="0" cellpadding="0" cellspacing="0">';
				
		// Show each option with its corresponding percentage bar.
		foreach ($poll['options'] as $option)
			echo '
											<tr>
												<td style="padding-right: 2ex;', $option['voted_this'] ? 'font-weight: bold;' : '', '">', $option['option'], '</td>', $poll['allow_poll_view'] ? '
												<td nowrap="nowrap">' . $option['bar'] . ' ' . $option['votes'] . ' (' . $option['percent'] . '%)</td>' : '', '
											</tr>';
				
		echo '
										</table>
									</td>
								</tr>
								<tr class="needsPadding">
									<td align="center">';
				
		// If they are allowed to revote - show them a link!
		if ($poll['allow_change_vote'])
			echo '
										<a href="', $scripturl, '?action=vote;topic=', $poll['topicID'], '.', $context['start'], ';poll=', $poll['id'], ';sesc=', $context['session_id'], '">', $txt['poll_change_vote'], '</a><br />';
				
		// If we're viewing the results... maybe we want to go back and vote?
		if ($poll['show_results'] && $poll['allow_vote'])
			echo '
										<a href="', $scripturl, '?topic=', $poll['topicID'], '.', $context['start'], '">', $txt['poll_return_vote'], '</a><br />';
				
		// If they're allowed to lock the poll, show a link!
		if ($poll['lock'])
			echo '
										<a href="', $scripturl, '?action=lockVoting;topic=', $poll['topicID'], '.', $context['start'], ';sesc=', $context['session_id'], '">', !$poll['is_locked'] ? $txt['smf30'] : $txt['smf30b'], '</a><br />';
				
		// If they're allowed to edit the poll... guess what... show a link!
		if ($poll['edit'])
			echo '<a href="', $scripturl, '?action=editpoll;topic=', $poll['topicID'], '.', $context['start'], '">', $txt['smf39'], '</a>';
				
		echo '
									</td>
								</tr>', $poll['allow_poll_view'] ? '
								<tr class="needsPadding">
									<td align="center"><b>' . $txt['smf24'] . ': ' . $poll['total_votes'] . '</b></td>
								</tr>' : '', '
							</table>';
	}
	// They are allowed to vote! Go to it!
	else
	{
		echo '
							<form action="', $scripturl, '?action=vote;topic=', $poll['topicID'], '.', $context['start'], ';poll=', $poll['id'], '" method="post" accept-charset="', $context['character_set'], '" style="margin: 0px;">
								<table>
									<tr class="needsPadding">
										<td>';
				
		// Show a warning if they are allowed more than one option.
		if ($poll['allowed_warning'])
			echo '
											', $poll['allowed_warning'], '
										</td>
									</tr>
									<tr class="needsPadding">
										<td>';
				
		// Show each option with its button - a radio likely.
		foreach ($poll['options'] as $option)
			echo '
											', $option['vote_button'], ' <label for="' . $option['id'] . '">', $option['option'], '</label><br />';
				
		echo '
										</td>
									</tr>
									<tr class="needsPadding">
										<td align="center">';
				
		// Allowed to view the results? (without voting!)
		if ($poll['allow_poll_view'])
			echo '
											<a href="', $scripturl, '?topic=', $poll['topicID'], '.', $context['start'], ';viewResults">', $txt['smf29'], '</a><br />';
				
		// Show a link for locking the poll as well...
		if ($poll['lock'])
			echo '
											<a href="', $scripturl, '?action=lockVoting;topic=', $poll['topicID'], '.', $context['start'], ';sesc=', $context['session_id'], '">', (!$poll['is_locked'] ? $txt['smf30'] : $txt['smf30b']), '</a><br />';
				
		// Want to edit it? Click right here......
		if ($poll['edit'])
			echo '<a href="', $scripturl, '?action=editpoll;topic=', $poll['topicID'], '.', $context['start'], '">', $txt['smf39'], '</a>';
				
		echo '
										</td>
									</tr>
									<tr class="needsPadding">
										<td align="center"><input type="submit" value="', $txt['smf23'], '" /></td>
									</tr>
								</table>
								
								<input type="hidden" name="sc" value="', $context['session_id'], '" />';
				
		if (empty($settings['use_tabs']))
			echo '
							</form>';
	}
	echo '
							</div>';
}


// this is the select form that let's users move windows around
function windowOrderSelect() {
	global $scripturl, $context, $txt, $blog;
	if (!empty($context['blog']['display_move_window_form'])) {
		$current_value = $context['blog']['settings'][$context['blog']['display_move_window_form'] . 'WindowOrder']['value'];
		echo '
								<form action="', $scripturl, '?action=blogControlPanel;u='. $context['blog']['controlPanelOwner']['id'] .';blog='. $blog .';sesc='. $context['session_id'] .';sa=customWindows;moveWindow='. $context['blog']['display_move_window_form'] . (!empty($_REQUEST['blogStart']) ? ';blogStart='. $_REQUEST['blogStart'] : '') .'" method="post" accept-charset="', $context['character_set'], '">
									<select name="'. $context['blog']['display_move_window_form'] .'WindowOrder">
										<option value="', !empty($current_value) ? $current_value : '', '" style="padding-right:6px;">', !empty($current_value) ? $current_value : '', '</option>';
										
		for ($i = 1; $i <= count($context['blog']['sideWindows']); $i++) {
	
			if ($i != $context['blog']['settings'][$context['blog']['display_move_window_form'] . 'WindowOrder']['value'])
				echo '
										<option value="'. $i .'" style="padding-right:6px;">'. $i .'</option>';
	
		}
							
		echo '
									</select>
									<input type="hidden" name="changeWinOrder" />
									<input type="submit" value="'. $txt['b23'] .'" />
								</form>';
	}
}


// this outputs form fields according to the defaultBlogSettings and admin_blog_settings arrays from prepareDefaultBlogSettings()
// makes it a lot easier to add new settings to or remove settings from the blog control panel
function template_displayFormField($setting, $array, $settingType)
{
	global $context, $txt, $scripturl, $settings, $blog, $modSettings, $settings;
	
	$hasPermission = !empty($array['permission']) ? (allowedTo($array['permission']) ? true : false) : true;
	$settingAvailable = !empty($array['requiresModSetting']) ? (!empty($modSettings[$array['requiresModSetting']]) ? true : false) : true;
			
	if ($hasPermission && $settingAvailable)
	{
		if (!empty($array['headerAbove']))
			echo '
						<tr class="needsPadding">
							<td colspan="2" width="100%" align="center"><hr size="1" width="100%" class="hrcolor" /></td>
						</tr>
						<tr class="needsPadding">
							<td colspan="2" width="100%" align="center" style="padding-bottom:12px;"><span class="controlPanelSectionHeader" style="font-weight:bold; font-size:14px;"><u>'. $array['headerAbove'] .'</u></span></td>
						</tr>';
		
		if (!empty($array['instructions']))
			echo '
						' . (empty($array['headerAbove']) ? '<tr class="needsPadding">
							<td colspan="2" width="40%" align="center"><hr size="1" width="40%" class="hrcolor" style="padding:0; margin:0; margin-top:2px;" /></td>
						</tr>' : '') . '
						<tr class="needsPadding">
							<td colspan="2" width="100%" align="center" style="font-size:12px;">'. $array['instructions'] .':</td>
						</tr>';
			
		if (empty($array['custom']))
		{
			echo '
						<tr class="needsPadding">
							<td width="50%" align="right"', !empty($context['blogSettings_errors']['messages']['no_' . $setting]) && !empty($array['required']) ? ' style="color:red;"' : '', '>'. ($array['type'] == 'check' ? '<label for="'. $setting .'">' : '') . $txt[$setting] . (!empty($array['helptext']) ? ' <a href="'. $scripturl .'?action=blogHelp'. (!empty($blog) ? ';blog='. $blog : '') .';help='. $setting .'" onclick="return reqWin(this.href);" class="help" rel="nofollow"><img src="'. $settings['default_theme_url'] .'/images/icons/QuestionIcon.gif" alt="(?)" /></a>' : '') . (!empty($array['subtext']) ? '<br /><span class="smalltext">'. $array['subtext'] .'</span>' : '') . ($array['type'] == 'check' ? '</label>' : '') . ' </td>
							<td width="50%" align="left">';
							
			if ($array['type'] == 'text')
				echo '
								<input type="text" name="'. $setting .'" value="', !empty($context['blog'][$settingType][$setting]['value']) ? $context['blog'][$settingType][$setting]['value'] : '', '" />';
			elseif ($array['type'] == 'int')
				echo '
								<input type="text" name="'. $setting .'" value="', isset($context['blog'][$settingType][$setting]['value']) ? $context['blog'][$settingType][$setting]['value'] : '', '" />';
			elseif ($array['type'] == 'check')
				echo '
								<input type="checkbox" id="'. $setting .'" name="'. $setting .'"', !empty($context['blog'][$settingType][$setting]['value']) ? ' checked="checked"' : ' value="1"', ' />';
								
		}
		elseif ($array['custom'] == 'hidden')
		{
				echo '
								<input type="hidden" name="'. $setting .'" value="', isset($context['blog'][$settingType][$setting]['value']) ? $context['blog'][$settingType][$setting]['value'] : '', '" />';
								
		}
		elseif ($array['custom'] == 'select')
		{
			echo '
						<tr class="needsPadding">
							<td width="50%" align="right">'. $txt[$setting] . (!empty($array['helptext']) ? ' <a href="'. $scripturl .'?action=blogHelp'. (!empty($blog) ? ';blog='. $blog : '') .';help='. $setting .'" onclick="return reqWin(this.href);" class="help" rel="nofollow"><img src="'. $settings['default_theme_url'] .'/images/icons/QuestionIcon.gif" alt="(?)" /></a>' : '') . (!empty($array['subtext']) ? '<br /><span class="smalltext">'. $array['subtext'] .'</span>' : '') . ' </td>
							<td width="50%" align="left">
								<select name="'. $setting .'">';
								
			if (isset($array['options'][$context['blog'][$settingType][$setting]['value']]))
				echo '
									<option value="'. $context['blog'][$settingType][$setting]['value'] .'">'. $array['options'][$context['blog'][$settingType][$setting]['value']] .'</option>';
							
			foreach ($array['options'] as $value => $option)
			{
				if ($value != $context['blog'][$settingType][$setting]['value'])
					echo '
									<option value="'. $value .'">'. $option .'</option>';
			}
			echo '	
								</select>
							</td>
						</tr>';
		}
		elseif ($array['custom'] == 'textarea')
		{
			echo '
						<tr class="needsPadding">
							<td width="50%" align="right"', !empty($context['blogSettings_errors']['messages']['no_' . $setting]) && !empty($array['required']) ? ' style="color:red;"' : '', '>'. $txt[$setting] . (!empty($array['helptext']) ? ' <a href="'. $scripturl .'?action=blogHelp'. (!empty($blog) ? ';blog='. $blog : '') .';help='. $setting .'" onclick="return reqWin(this.href);" class="help" rel="nofollow"><img src="'. $settings['default_theme_url'] .'/images/icons/QuestionIcon.gif" alt="(?)" /></a>' : '') . (!empty($array['subtext']) ? '<br /><span class="smalltext">'. $array['subtext'] .'</span>' : '') . ' </td>
							<td width="50%" align="left">
								<textarea name="'. $setting .'" style="width:300px;height:60px;">', !empty($context['blog'][$settingType][$setting]['value']) ? $context['blog'][$settingType][$setting]['value'] : '', '</textarea>
							</td>
						</tr>';
		}
		elseif ($array['custom'] == 'multiCheck')
		{			
			if (!empty($array['options']))
			{
				foreach ($array['options'] as $id => $option)
					echo '
						<tr class="needsPadding">
							<td width="50%" align="right"><label for="'. $setting . $id .'">'. $option .' </label></td>
							<td width="50%" align="left">
								<input type="checkbox" name="'. $setting .'[]" id="'. $setting . $id .'"', !empty($context['blog'][$settingType][$setting]['value']) ? (in_array($id, $context['blog'][$settingType][$setting]['value']) ? ' checked="checked"' : '') : '', ' value="'. $id .'" />
							</td>
						</tr>';
			}
			// check/uncheck all
			echo '
						<tr class="needsPadding">
							<td width="50%" align="right"><i>'. $txt[737] .'</i> </td>
							<td width="50%" align="left">
								<input type="checkbox" onclick="invertAll(this, this.form, \''. $setting .'[]\');" class="check" />
							</td>
						</tr>';
		}
		elseif ($array['custom'] == 'radio')
		{	
			if (!empty($array['options']))
			{
				foreach ($array['options'] as $id => $option)
					echo '
						<tr class="needsPadding">
							<td width="50%" align="right">
								<input type="radio" name="'. $setting .'" id="'. $setting . $id .'" class="check" value="'. $id .'"', isset($context['blog'][$settingType][$setting]['value']) ? ($context['blog'][$settingType][$setting]['value'] == $id ? ' checked="checked"' : '') : '', ' /> 
							</td>
							<td width="50%" align="left"><label for="'. $setting . $id .'">'. $option .'</label></td>
						</tr>';
			}
		
		}
		elseif ($array['custom'] == 'require_url_verification')
		{
					echo '
						<tr class="needsPadding">
							<td width="50%" align="right"', !empty($context['blogSettings_errors']['messages']['no_' . $setting]) && !empty($array['required']) ? ' style="color:red;"' : '', '>'. $txt[$setting] . (!empty($array['helptext']) ? ' <a href="'. $scripturl .'?action=blogHelp'. (!empty($blog) ? ';blog='. $blog : '') .';help='. $setting .'" onclick="return reqWin(this.href);" class="help" rel="nofollow"><img src="'. $settings['default_theme_url'] .'/images/icons/QuestionIcon.gif" alt="(?)" /></a>' : '') . (!empty($array['subtext']) ? '<br /><span class="smalltext">'. $array['subtext'] .'</span>' : '') . ' </td>
							<td width="50%" align="left">
								<input type="text" name="'. $setting .'" value="' . (!empty($context['blog'][$settingType][$setting]['value']) ? $context['blog'][$settingType][$setting]['value'] : '') . '" /> ' . (($context['blog']['verification'][$setting] == 1) ? '<img src="'. $settings['default_theme_url'] .'/images/icons/icon_success.gif" alt="'. $txt['b38'] .'" />' : (!empty($context['blog'][$settingType][$setting]['value']) ? (empty($_SESSION['retry_verification_attempt'][$setting]) ? '<a href="'. $scripturl .'?action=blogControlPanel;u='. $context['blog']['controlPanelOwner']['id'] . (!empty($blog) ? ';blog='. $blog : '') . ';sa=blogSettings;retryVer='. $setting . (!empty($_REQUEST['blogStart']) ? ';blogStart='. $_REQUEST['blogStart'] : '') .'#verify'. $setting .'" title="'. $txt['retry_verification'] .'" rel="nofollow"><img src="'. $settings['default_theme_url'] .'/images/icons/failure_icon.gif" alt="'. $txt['b39'] .'" /></a>' : '<img src="'. $settings['default_theme_url'] .'/images/icons/failure_icon.gif" alt="'. $txt['b39'] .'" />') : '')) . '
							</td>
						</tr>';
		}
		if (empty($array['custom']))
			echo '
							</td>
						</tr>';
	}
}


// this is simply an error table... displays a message detailing all the errors that occurred during a form submission
// also displays success messages
function template_errorSuccessTable($messages, $type, $success = null) {
	global $txt, $context;
	echo '
	<table border="0" width="100%" cellspacing="1" cellpadding="4" align="center" id="'. $type .'" class="bordercolor">
		<tr class="windowbg2">
			<td align="center">
				<div style="font-weight: bold;">
					'. ($success ? '<span style="font-size:14px;">'. $txt['b32'] .'!</span>' : $txt['errors_while_' . $type]) .'
				</div>
				<div style="margin:1ex 0 1ex 0;">
					'. (is_array($messages) ? implode('<br />', $messages) : $messages) .'
				</div>
			</td>
		</tr>
	</table>
	<br />';
}


function template_listControlPanelItems($type, $subMenu = null)
{
	global $txt, $settings, $context, $scripturl, $blog;
						
	$item_names = array(
		'blogLinks' => $txt['b72'],
		'blogCategories' => $txt['b73'],
		'customWindows' => $txt['b74'],
		'blogTags' => $txt['b77'],
		'usersAllowedToBlog' => $txt['b85'],
	);
	
	$iniCount = count($context['blog']['listInfo'][$type]);
	if (empty($_REQUEST['move']))
		$iniCount = $iniCount + 1;
		
	$numColumns = $iniCount;
	
	if (!empty($context[$type][0]['preview_link']))
		$numColumns++;
	if (!empty($context[$type][0]['edit_link']))
		$numColumns++;
	if (!empty($context[$type][0]['move_link']))
		$numColumns++;
	if (!empty($context[$type][0]['remove_link']))
		$numColumns++;

	echo '
	<table border="0" cellspacing="1" cellpadding="0" class="bordercolor" width="100%"><tr><td width="100%">
	<table border="0" width="100%" cellspacing="0" cellpadding="4" align="center" id="'. $type .'">
		<tr class="catbg">
			<td colspan="'. (in_array($type, array('blogTags', 'usersAllowedToBlog')) ? $numColumns : $numColumns - 1) .'" height="26" style="vertical-align:middle;" width="100%">
				&nbsp;<img src="'. $settings['images_url'] .'/icons/profile_sm.gif" alt="" style="vertical-align:middle;" />&nbsp;'. $txt[$type] .'
			</td>
			<td align="right" style="padding:6px;vertical-align:middle; font-weight:normal;" width="100">'. (!empty($context['page_index']) && !empty($context['show_page_index']) ? $txt['b63'] . ': ' . $context['page_index'] : '') .'</td>
		</tr>
'. (empty($_REQUEST['move']) && !empty($context[$type]) ? '
		<form action="'. $scripturl .'?action=blogControlPanel;u='. $context['blog']['controlPanelOwner']['id'] .';blog='. $blog .';sesc='. $context['session_id'] . (!empty($_REQUEST['sa']) ? ';sa='. $_REQUEST['sa'] : '') . ';' . $type . '=delete;' . (!empty($_REQUEST['blogStart']) ? ';blogStart='. $_REQUEST['blogStart'] : '') .'" method="post" accept-charset="'. $context['character_set'] .'">' : '') . '';
	if (!empty($context[$type]))
	{
		echo '
		<tr class="windowbg2">
			<td colspan="'. (in_array($type, array('blogTags', 'usersAllowedToBlog')) ? $numColumns + 1 : $numColumns) .'">
				<table border="0" width="100%" cellspacing="0" cellpadding="4" align="center">';
		// display column headers
		if (!empty($context['blog']['listInfo'][$type]) && (empty($context[$type][0]) || count($context[$type]) > 1 || (count($context[$type]) == 1 && !empty($context[$type][0]['showMove']))))
		{
			echo '
					<tr class="needsPadding">
						<td colspan="'. (in_array($type, array('blogTags', 'usersAllowedToBlog')) ? $numColumns : $numColumns - 1) .'"></td>
						' . (empty($_REQUEST['move']) ? '
						<td width="25" align="right"><input type="checkbox" onclick="invertAll(this, this.form, \'items[]\');" class="check" /></td>' : '') . '
					</tr>
				</table>
			</td>
		</tr>';
		}
	
		// display each item
		$c=0;
		foreach ($context[$type] as $key => $item)
		{
			if (!empty($key))
			{
			$c++;
				// start a move form
				if (!empty($item['showMove']))
					echo '
		<form method="post" action="'. $scripturl .'?action=blogControlPanel;u='. $context['blog']['controlPanelOwner']['id'] .';blog='. $blog .';'. $type .'=move' . ';sesc='. $context['session_id'] . ';move=' . $item['id'] . ';sa='. (!empty($subMenu) ? $subMenu : $type) . (!empty($_REQUEST['blogStart']) ? ';blogStart='. $_REQUEST['blogStart'] : '') .'#'. (!empty($subMenu) ? $subMenu : $type) .'" accept-charset="'. $context['character_set'] .'">
		<input type="hidden" name="id" value="'. $item['id'] .'" />';
						
				echo '
		<tr class="windowbg', $c%2 ? '' : '2' ,'">
			<td align="center" style="white-space:nowrap;" width="100">';
							
				// first column... item link/name
				if (!empty($item['link']))
					echo $item['link'];
				else
					echo $item['name'];
					
				echo '
			</td>';
							
				// additional columns
				if (count($context['blog']['listInfo'][$type]) > 1)
					foreach ($context['blog']['listInfo'][$type] as $field => $array)
						if (($field != 'name'))
							echo '
			<td width="150"'. (!empty($array['unAlignItems']) ? '' : ' align="' . (!empty($array['align']) ? $array['align'] : 'left') . '"') . (!empty($array['nowrap']) ? ' style="white-space:nowrap;"' : '') . '>'. $item[$field] .'</td>';
					
				// preview link?
				if (!empty($item['preview_link']))
					echo '
			<td width="25" align="center">'. $item['preview_link'] .'</td>';
					
				// second column... either an edit link or a move form
				if (!empty($item['edit_link']) || !empty($item['showMove']))
				{
					echo '
			<td width="25" align="center">';
							
					if (!empty($item['showMove']))
						template_moveForm($item, $type);
					else
						echo $item['edit_link'];
							
					echo '
			</td>';
				}
					
				// third column... either a move link or a move submit button
				if (!empty($item['move_link']) || !empty($item['showMove']))
				{
					echo '
			<td width="25" align="center">';
							
					if (!empty($item['showMove']))
						echo '
				<input type="submit" value="'. $txt['b19'] .'" />';
					else
						echo $item['move_link'];
							
					echo '
			</td>';
				}
					
				// fourth column... remove link 
				// fifth column... checkbox for multiple deletions at once
				echo '
			<td width="25" align="center">' . (!empty($item['remove_link']) ? $item['remove_link'] : '') . '</td>
			' . (empty($_REQUEST['move']) ? '
			<td'. ($type == 'usersAllowedToBlog' ? ' colspan="2"' : '') .' width="25" valign="middle" align="right" style="padding-right:8px;"><input type="checkbox" name="items[]" value="'. $item['id'] .'" class="check" /></td>' : '') . '
		</tr>';
					
				// close the form	
				if (!empty($item['showMove']))
					echo '
	</form>';
			}
		}
	}
	else
		echo '
		<tr class="windowbg2">
			<td colspan="', (in_array($type, array('blogTags', 'usersAllowedToBlog')) ? $numColumns : $numColumns - 1), '">', $txt['no_' . $type], '</td>
			<td align="right" width="30">', !empty($context['blog']['help_' . $type]) ? $context['blog']['help_' . $type] : '', '</td>
		</tr>';
		
	echo '
		' . (empty($_REQUEST['move']) && !empty($context[$type]) ? '
		<tr class="windowbg2">
			<td align="left" style="padding:6px;">'. (!empty($context['show_page_index']) ? '<a href="'. $scripturl .'?action=blogControlPanel;u='. $context['blog']['controlPanelOwner']['id'] .';blog='. $blog .';sa='. (!empty($subMenu) ? $subMenu : $type) . (!empty($_REQUEST['blogStart']) ? ';blogStart='. $_REQUEST['blogStart'] : '') .';all">'. $txt['b81'] .'</a>' : '') . '
			</td>
			<td colspan="'. (in_array($type, array('blogTags', 'usersAllowedToBlog')) ? $numColumns : $numColumns - 1) .'" align="right" style="padding:6px;"><input type="submit" value="'. $txt['smf138'] .'" onclick="return confirm(\''. $txt['b71'] . $item_names[$type] .'?\');" />
			</td>
		</tr>
	</form>' : '') . '
	</table>
	</td></tr></table><br />';
}


// echos a select form field specifically for reordering things
function template_moveForm($data, $type)
{
	global $context;
	echo '
		<select name="order" style="width:50px;">
			<option value="'. $data['order'] .'">'. $data['order'] .'</option>';
		foreach ($context['ordersof_' . $type] as $order)
			if ($order != $data['order'])
				echo '
			<option value="'. $order .'">'. $order .'</option>';
	echo '
		</select>';
}


// creates a table with form for adding something
function template_addForm($type, $subMenu = null)
{
	global $txt, $context, $scripturl, $settings, $blog;
	$_REQUEST['edit'] = isset($_REQUEST['edit']) ? (int) $_REQUEST['edit'] : '';
	$editItem = !empty($_REQUEST['edit']) && !empty($context[$type][$_REQUEST['edit']]) ? $context[$type][$_REQUEST['edit']] : null;
	$editing = !empty($editItem) ? true : false;
	$formFunction = 'template_' . $type . 'EditForm';
	echo '
	<table border="0" width="100%" cellspacing="1" cellpadding="0" class="bordercolor"><tr><td width="100%">
				<table border="0" width="100%" cellspacing="0" cellpadding="4" align="center" id="add">
					<form method="post" action="'. $scripturl .'?action=blogControlPanel;u='. $context['blog']['controlPanelOwner']['id'] .';blog='. $blog .';'. $type .'=' . (!empty($editing) ? 'edit' : 'add') . (!empty($editing) ? ';edit=' . $_REQUEST['edit'] : '') . ';sesc='. $context['session_id'] .';sa='. (!empty($subMenu) ? $subMenu : $type) . (!empty($_REQUEST['blogStart']) ? ';blogStart='. $_REQUEST['blogStart'] : '') .'#'. (!empty($subMenu) ? $subMenu : $type) .'">
					<tr class="catbg">
						<td height="26">
							&nbsp;<img src="'. $settings['images_url'] .'/icons/profile_sm.gif" alt="" align="top" />&nbsp;' . (!empty($editing) ? $txt['edit_' . $type] : $txt['add_' . $type]) . '
						</td>
					</tr>
					<tr class="windowbg2">
						<td width="100%">
							<table border="0" cellspacing="0" cellpadding="4" width="100%" align="center">
								<tr>
									<td align="center">';
	
	$formFunction($editItem);
							
	echo '
									</td>
								</tr>
								<tr>
									<td align="center">
										' . (!empty($editing) ? '<input type="hidden" name="id" value="'. $_REQUEST['edit'] .'" />' : '') . '
										<input type="submit" value="' . (!empty($editing) ? $txt['b17'] : $txt['b18']) . '" />
									</td>
								</tr>
							</table>
						</td>
					</tr>
					</form>
				</table>
	</td></tr></table><br />';
}



function template_customWindowsEditForm($window = null)
{
	global $context, $txt;
	echo '
		<table border="0" width="100%" cellpadding="4" cellspacing="0">
			<tr class="needsPadding">
				<td width="50%" align="right"', !empty($context['customWindows_errors']['messages']['no_title']) ? ' style="color:red;"' : '', '><span style="white-space:nowrap;">'. $txt[196] .'</span></td>
				<td width="50%" align="left">
					<input name="titleCustomWindow" value="'. (!empty($_POST['titleCustomWindow']) ? $_POST['titleCustomWindow'] : (!empty($window['title']) ? $window['title'] : '')) .'" />
				</td>
			</tr>
			<tr class="needsPadding">
				<td width="50%" align="right"', !empty($context['customWindows_errors']['messages']['no_content']) ? ' style="color:red;"' : '', '><span style="white-space:nowrap;">'. $txt['contentCustomWindow'] .'</span></td>
				<td width="50%" align="left">
					<textarea name="contentCustomWindow" style="width:360px; height:90px;">'. (!empty($_POST['contentCustomWindow']) ? $_POST['contentCustomWindow'] : (!empty($window['content']) ? $window['content'] : '')) .'</textarea>
				</td>
			</tr>
		</table>';
}



function template_blogLinksEditForm($link = null)
{
	global $context, $txt;
	echo '
		<table border="0" width="100%" cellpadding="4" cellspacing="0">
			<tr class="needsPadding">
				<td width="50%" align="right"', !empty($context['blogLinks_errors']['messages']['no_linkName']) ? ' style="color:red;"' : '', '><span style="white-space:nowrap;">'. $txt['blog_linkName'] .'</span></td>
				<td width="50%" align="left">
					<input name="linkName" value="'. (!empty($_POST['linkName']) ? $_POST['linkName'] : (!empty($link['name']) ? $link['name'] : '')) .'" />
				</td>
			</tr>
			<tr class="needsPadding">
				<td width="50%" align="right"', !empty($context['blogLinks_errors']['messages']['no_url']) ? ' style="color:red;"' : '', '><span style="white-space:nowrap;">'. $txt['blog_url'] .'</span></td>
				<td width="50%" align="left">
					<input name="url" value="'. (!empty($_POST['url']) ? $_POST['url'] : (!empty($link['url']) ? $link['url'] : '')) .'" />
				</td>
			</tr>
			<tr class="needsPadding">
				<td width="50%" align="right"', !empty($context['blogLinks_errors']['messages']['no_title']) ? ' style="color:red;"' : '', '><span style="white-space:nowrap;">'. $txt['blog_title'] .'</span></td>
				<td width="50%" align="left">
					<input name="title" value="'. (!empty($_POST['title']) ? $_POST['title'] : (!empty($link['title']) ? $link['title'] : '')) .'" />
				</td>
			</tr>
		</table>';
}


function template_blogCategoriesEditForm($category = null)
{
	global $context, $txt;
	echo '
		<table border="0" width="100%" cellpadding="4" cellspacing="0">
			<tr class="needsPadding">
				<td width="50%" align="right"', !empty($context['blogCategories_errors']['messages']['no_categoryName']) ? ' style="color:red;"' : '', '><span style="white-space:nowrap;">'. $txt['categoryName'] .'</span></td>
				<td width="50%" align="left">
					<input name="categoryName" value="'. (!empty($_POST['categoryName']) ? $_POST['categoryName'] : (!empty($category['name']) ? $category['name'] : '')) .'" />
				</td>
			</tr>
		</table>';
}


function template_usersAllowedToBlogEditForm($blogger = null)
{
	global $context, $txt;
	echo '
		<table border="0" width="100%" cellpadding="4" cellspacing="0">
			<tr class="needsPadding">
				<td width="50%" align="right"', !empty($context['postingRestrictions_errors']['messages']['no_blogger']) ? ' style="color:red;"' : '', '><span style="white-space:nowrap;">' . $txt['add_blogger'] . '</span></td>
				<td width="50%" align="left">
					<input name="addBlogger" value="'. (!empty($_POST['addBlogger']) ? $_POST['addBlogger'] : '') .'" />
				</td>
			</tr>
		</table>';
}




/*
				 - - - - - - - - - - - -
			 BLOG CONTROL PANEL SUB-TEMPLATES
				 - - - - - - - - - - - -
*/


function template_safeGuard()
{
	global $settings, $txt, $scripturl, $context;
	echo '
	<table border="0" width="100%" cellspacing="1" cellpadding="0" align="center" class="bordercolor"><tr><td valign="top" align="center">
		<table border="0" width="100%" cellspacing="0" cellpadding="4" align="center">
			<tr class="catbg">
				<td height="26">
					&nbsp;<img src="'. $settings['images_url'] .'/icons/profile_sm.gif" alt="" align="top" />&nbsp;'. $txt['blog_are_you_sure'] .'
				</td>
			</tr>
			<tr class="windowbg2">
				<td align="center" style="padding:8px;">'. $context['blog']['confirm_text'] .'</td>
			</tr>
			<tr class="windowbg2">
				<td align="center">
					<table border="0" cellspacing="0" cellpadding="4" align="center" class="tborder">';
	foreach ($context['blog']['requires_confirmation'] as $blog)
		echo '
						<tr class="windowbg"><td align="center">'. $context['blog']['blog_names'][$blog] .'</td></tr>';
	echo '
					</table>
				</td>
			</tr>
			<tr class="windowbg2" style="font-size:11px;">
				<td align="center" style="padding:8px;"><a href="'. $scripturl .'?action=blogControlPanel;u='. $context['blog']['controlPanelOwner']['id'] .';sa=deleteBlog;deleteBlog='. urlencode(implode(',', $context['blog']['requires_confirmation'])) .';safeGuard='. $context['session_id'] .';sesc='. $context['session_id'] .'" rel="nofollow">'. $txt['b67'] .'</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="'. $scripturl .'?action=blogControlPanel;u='. $context['blog']['controlPanelOwner']['id'] .'" rel="nofollow">'. $txt['modify_cancel'] .'</a></td>
			</tr>
		</table>
	</td></tr></table>';
}



function template_BCP_below()
{
	echo '
		</td></tr></table>';
}


function template_BCP_above()
{
	global $context, $settings, $options, $scripturl, $txt, $modSettings, $user_info, $blog;
	if (!$user_info['is_admin'])
		echo '
		<br />';
	
	echo '
		<table border="0" width="100%" cellspacing="0" cellpadding="4" align="center"><tr><td valign="top" align="center">
		<table border="0" width="100%" cellspacing="1" cellpadding="0" align="center" class="bordercolor"><tr><td width="100%">
			<table border="0" width="100%" cellspacing="0" cellpadding="6" align="center">
				<tr class="catbg">
					<td height="26">
						&nbsp;<img src="'. $settings['images_url'] .'/icons/profile_sm.gif" alt="" align="top" />&nbsp;'. $context['page_title'] .'
					</td>
					<td align="right" style="padding:6px; white-space:nowrap;">'. (!empty($context['blog_page_index']) && !empty($context['show_blog_page_index']) ? '<span style="font-weight:normal;">' . $txt['b63'] . ':</span> '. $context['blog_page_index'] : '') .'</td>
				</tr>' . ($context['is_controlPanelOwner'] ? '
				<tr class="windowbg">
					<td colspan="2">'. $txt['blog_welcome_control_panel'] .'</td>
				</tr>' : '') . '
				<tr class="windowbg">
					<td colspan="2">';
	// show message containing # of blogs they have and a link to create a new one OR a messge saying they have the maximum
	if ($context['num_of_blogs'] < $modSettings['max_num_blogs'] || $user_info['is_admin'])
		echo (!$context['is_controlPanelOwner'] && !empty($context['blog']['controlPanelOwner']['name']) ? $txt['b6'] . ' ' . $txt['b5'] . ' ' . $txt['b4'] : $txt['b2'] . ' ' . $txt['b3']) . ' ' . $context['num_of_blogs'] . ' ' . ($context['num_of_blogs'] == 1 ? $txt['blog'] : $txt['b1']) . '.' . (($context['can_make_multiple_blogs'] && ($context['num_of_blogs'] > 0)) ? '  ' . $txt['admin_initialize_another_blog'] : '') . (!$context['can_make_multiple_blogs'] && !$context['blog_is_initialized'] ? '  ' . $txt['admin_have_not_initialized_blog'] : '') . (($context['can_make_multiple_blogs'] && ($context['num_of_blogs'] == 0)) ? '  ' . $txt['admin_initialize_a_blog'] : '');
	else
		echo $txt['maximum_num_of_blogs_achieved'];
		
	echo '
					</td>
				</tr>';
			
	if (!empty($context['init_failure']))
		echo '
				<tr class="windowbg2" style="color:red;text-align:center;">
					<td colspan="2" style="color:red;">'. $txt['error_init_failure'] .'</td>
				</tr>';
			
	echo '
			</table>
		</td></tr></table>';
			
	// show the tab menu (main, blog 1, blog 2, etc)
	echo '
	<table border="0" width="100%" cellspacing="0" cellpadding="0" align="center"><tr><td width="100%">
		<table border="0" cellspacing="0" cellpadding="0" style="margin-left: 10px;" align="left">
			<tr>
				<td class="maintab_first">&nbsp;</td>';
				
	echo ($context['show_control_panel_home'] || $context['browser']['is_ie4']) ? '
				<td class="maintab_active_first">&nbsp;</td>' : '' , '
				<td valign="middle" class="maintab_' , $context['show_control_panel_home'] ? 'active_back' : 'back' , '" style="text-transform:none;font-size:12px;">
					<a href="'. $scripturl .'?action=blogControlPanel;u='. $context['blog']['controlPanelOwner']['id'] .'" rel="nofollow" style="line-height:125%;">'. $txt['b28'] .'</a>
				</td>', $context['show_control_panel_home'] ? '<td class="maintab_active_last">&nbsp;</td>' : '';
	
	if (!empty($context['my_blogs']))
	{
		if (count($context['my_blogs']) > 5)
			$sliced_blogs = array_slice($context['my_blogs'], 0, 5);
		else
			$sliced_blogs = $context['my_blogs'];
			
		$previous_is_active = $context['show_control_panel_home'];
		foreach ($sliced_blogs as $this_blog)
		{
			echo ($this_blog['id'] == $blog || $context['browser']['is_ie4']) ? '
				<td class="maintab_active_first">&nbsp;</td>' : (!$previous_is_active ? '<td valign="middle" class="maintab_divider">|</td>' : '') , '
				<td valign="middle" class="maintab_' , $this_blog['id'] == $blog ? 'active_back' : 'back' , '" style="text-transform:none;font-size:12px;">
					<a href="'. $scripturl .'?action=blogControlPanel;u='. $context['blog']['controlPanelOwner']['id'] .';blog='. $this_blog['id'] . (!empty($_REQUEST['blogStart']) ? ';blogStart='. $_REQUEST['blogStart'] : '') .'" style="white-space:nowrap;line-height:125%;" rel="nofollow">'. $this_blog['name'] .'</a>
				</td>', $this_blog['id'] == $blog ? '<td class="maintab_active_last">&nbsp;</td>' : '';
			$previous_is_active = $this_blog['id'] == $blog;
		}
	}
		
	echo '
				<td class="maintab_last">&nbsp;</td>
			</tr>
		</table>
	</td></tr></table><br />';
		
	// If an error or a success occurred, explain what happened
	if (!empty($context['blog']['current_subMenu']) && (!empty($context[$context['blog']['current_subMenu'] . '_errors']['messages']) || !empty($context[$context['blog']['current_subMenu'] . '_success']['messages'])))
	{
		$messages = !empty($context[$context['blog']['current_subMenu'] . '_errors']['messages']) ? $context[$context['blog']['current_subMenu'] . '_errors']['messages'] : $context[$context['blog']['current_subMenu'] . '_success']['messages'];
		$success = !empty($context[$context['blog']['current_subMenu'] . '_errors']['messages']) ? false : true;
		template_errorSuccessTable($messages, $context['blog']['current_subMenu'], $success);
	}
			
	// show the secondary tab menu
	if (!empty($context['blog']['current_subMenu']))
	{
		echo '
	<table border="0" width="100%" cellspacing="0" cellpadding="0" align="center"><tr><td width="100%">';
	
		// "Write Article" and "Go to Blog" links
		if (!empty($blog))
			echo '
		<table align="left" border="0" cellspacing="0" cellpadding="0" style="margin-left: 10px; line-height:135%;">
			<tr>
				<td class="mirrortab_first">&nbsp;</td>
				<td valign="middle" class="mirrortab_back" style="text-transform:none;font-size:11px;"><a href="'. $scripturl .'?action=post;board='. $blog .'" rel="nofollow">'. $txt['b76'] .'</a></td>
				<td valign="middle" class="mirrortab_divider">|</td>
				<td valign="middle" class="mirrortab_back" style="text-transform:none;font-size:11px;"><a href="'. $scripturl .'?blog='. $blog .'" rel="nofollow">'. $txt['goToBlog'] .'</a></td>
				<td class="mirrortab_last">&nbsp;</td>
			</tr>
		</table>';
	
		if (!empty($context['subMenu']))
		{
			echo '
		<table align="right" border="0" cellspacing="0" cellpadding="0" style="margin-right: 10px; line-height:135%;">
			<tr>
				<td class="mirrortab_first">&nbsp;</td>';
			$previous_is_active = false;
			$c=0;
			foreach ($context['subMenu'] as $item => $name)
			{
				echo ((($item == $context['blog']['current_subMenu']) || $context['browser']['is_ie4']) ? '
				<td class="mirrortab_active_first">&nbsp;</td>' : (!empty($c) && !$previous_is_active ? '<td valign="middle" class="mirrortab_divider">|</td>' : '')) . '
				<td valign="middle" class="mirrortab_' . ($item == $context['blog']['current_subMenu'] ? 'active_back' : 'back') . '" style="text-transform:none;font-size:11px;">
					<a href="'. $scripturl .'?action=blogControlPanel;u='. $context['blog']['controlPanelOwner']['id'] . (!empty($blog) ? ';blog=' . $blog : '') . ';sa='. $item . (!empty($_REQUEST['blogStart']) ? ';blogStart='. $_REQUEST['blogStart'] : '') .'" rel="nofollow" style="white-space:nowrap;">'. $name .'</a>
				</td>'. ($item == $context['blog']['current_subMenu'] ? '<td class="mirrortab_active_last">&nbsp;</td>' : '');
				$previous_is_active = $item == $context['blog']['current_subMenu'];
				$c++;
			}
			echo '
				<td class="mirrortab_last">&nbsp;</td>
			</tr>
		</table>';
		}
		echo '
	</td></tr></table>';
	}
}


function template_blogSettings()
{
	global $scripturl, $settings, $txt, $context, $blog;
	
	template_BCP_above();
	
	echo '
	<table border="0" width="100%" cellspacing="1" cellpadding="0" align="center" class="bordercolor"><tr><td width="100%">
				<table border="0" width="100%" cellspacing="0" cellpadding="4" align="center">
					<tr class="catbg">
						<td height="26">
							&nbsp;<img src="'. $settings['images_url'] .'/icons/profile_sm.gif" alt="" align="top" />&nbsp;'. $txt['blog_settings'] .'
						</td>
					</tr>
					<tr class="windowbg2">
						<td width="100%">
							<form action="'. $scripturl .'?action=blogControlPanel;u='. $context['blog']['controlPanelOwner']['id'] .';blog='. $blog .';sa=saveBlogSettings;sesc='. $context['session_id'] . (!empty($_REQUEST['blogStart']) ? ';blogStart='. $_REQUEST['blogStart'] : '') .'" method="post" accept-charset="', $context['character_set'], '">
							<table width="100%" border="0" cellspacing="0" cellpadding="4" align="center">';
					
	foreach ($context['blog']['defaultSettings'] as $setting => $array)
		template_displayFormField($setting, $array, 'settings');
					
	echo '
								<tr>
									<td colspan="2" width="100%" align="center"><hr size="1" width="100%" class="hrcolor" /></td>
								</tr>
								
								<tr>
									<td colspan="2" align="center">
										<input type="hidden" name="saveBlogSettings" />
										<input type="submit" value="'. $txt[10] .'" />
									</td>
								</tr>
							</table>
							</form>
						</td>
					</tr>
				</table>
	</td></tr></table><br />';
	
	template_BCP_below();
}



function template_manageBlogs()
{
	global $settings, $context, $user_info, $txt, $modSettings, $scripturl;
	template_BCP_above();
	echo '
	<table border="0" width="100%" cellspacing="1" cellpadding="0" align="center" class="bordercolor"><tr><td width="100%">
				<table border="0" width="100%" cellspacing="0" cellpadding="4" align="center" style="line-height:115%;">
				<form action="'. $scripturl .'?action=blogControlPanel;u='. $context['blog']['controlPanelOwner']['id'] .';sesc='. $context['session_id'] .';sa=deleteBlog;' . (!empty($_REQUEST['blogStart']) ? ';blogStart='. $_REQUEST['blogStart'] : '') .'" method="post" accept-charset="'. $context['character_set'] .'">
					<tr class="catbg">
						<td colspan="6" height="26">
							&nbsp;<img src="'. $settings['images_url'] .'/icons/profile_sm.gif" alt="" align="top" />&nbsp;', !$context['is_controlPanelOwner'] && !empty($context['blog']['controlPanelOwner']['name']) ? $context['blog']['controlPanelOwner']['name'] . '\'s ' . $txt['b1a'] : $txt['your_blogs'], '
						</td>
						<td align="right" style="padding:6px;">' . (!empty($context['my_blogs']) ? '<input type="checkbox" onclick="invertAll(this, this.form, \'blogs[]\');" class="check" />' : '') . '</td>
					</tr>
				</table>';
			
	if (!empty($context['my_blogs']))
	{
		$num_blogs = count($context['my_blogs']);
		$c=0;
		foreach ($context['my_blogs'] as $this_blog)
		{
			$c++;
			echo '
				<table border="0" width="100%" cellspacing="0" cellpadding="4" align="center">
					<tr class="windowbg', $c%2 ? '' : '2' ,'">
						<td valign="middle" width="250" style="padding-left:16px;">
							<table border="0" cellpadding="0" cellspacing="0" width="100%" style="line-height:125%;" class="noPadding">
								<tr>
									<td>'. $this_blog['link'] .'</td>
								</tr>
								', !empty($this_blog['description']) ? '
								<tr>
									<td style="font-size:11px;">'. $this_blog['description'] .'</td>
								</tr>' : '', '
							</table>
						</td>
						<td valign="middle" width="75" align="center">
							<span style="white-space:nowrap;">'. $this_blog['numArticles'] .' ', $this_blog['numArticles'] == 1 ? $txt['b66'] : $txt['b66a'], '</span><br /><span style="white-space:nowrap;">'. $this_blog['numComments'] .' ', $this_blog['numComments'] == 1 ? $txt['b15'] : $txt['b15a'], '</span>
						</td>
						<td valign="middle" width="75" align="center">
							<span style="white-space:nowrap;">'. $this_blog['blogViews'] .' ', $this_blog['blogViews'] == 1 ? $txt[305] : $txt[301], '</span>
						</td>
						<td valign="middle" width="250">';
				
			if (!empty($this_blog['last_post']['subject']))
				echo '
							<table border="0" cellpadding="0" cellspacing="0" width="100%" style="line-height:125%;" class="noPadding">
								<tr>
									<td><b>'. $txt[22] . '</b> ' . $txt[525] . ' ', $this_blog['last_post']['poster']['link'], '</td>
								</tr>
								<tr>
									<td>'. $txt['smf88'] . ' ' . $this_blog['last_post']['link'] .'</td>
								</tr>
								<tr>
									<td> '. $txt[30] .' '. $this_blog['last_post']['posterTime'] .'</td>
								</tr>
							</table>';
					
			echo '
						</td>'. (!empty($modSettings['xmlnews_enable']) && !empty($modSettings['showRSSFeedsOnBlogIndex']) ? '
						<td valign="middle" width="40" align="center">
							<a href="' . $scripturl . '?action=.xml;board=' . $this_blog['id'] . ';type=rss" title="'. $txt['rss_feed'].'"><img src="'. $settings['default_theme_url'] .'/images/icons/medium_rss_icon.png" alt="rss" /></a>
						</td>' : '') . ($context['can_delete_own_blogs'] ? '
						<td valign="middle" align="center" style="width:30px;">'. $this_blog['delete_link'] .'</td>
						<td valign="middle" align="center" style="width:16px;"><input type="checkbox" name="blogs[]" value="'. $this_blog['id'] .'" class="check" /></td>' : '') . '
					</tr>
				</table>';
		}
			
	}
	else
			echo '
				<table border="0" width="100%" cellspacing="0" cellpadding="4" align="center">
					<tr class="windowbg2"><td colspan="7">'. ($user_info['is_admin'] && !$context['is_controlPanelOwner'] ? $txt['b54'] : $txt['b53']) .'</td></tr>
				</table>';
			
	echo '
				<table border="0" cellspacing="0" cellpadding="0" width="100%">
					<tr class="windowbg2">
						<td colspan="3" align="left" style="padding:6px;">', !empty($context['show_blog_page_index']) ? '<a href="'. $scripturl .'?action=blogControlPanel;u='. $context['blog']['controlPanelOwner']['id'] .';all">'. $txt['b81'] .'</a>' : '', '</td>
						<td colspan="4" align="right" style="padding:6px;">
							<input type="submit" value="'. $txt['smf138'] .'" onclick="return confirm(\''. $txt['b71'] . $txt['b1'] .'?\');" />
						</td>
					</tr>
				</form>
				</table>
	</td></tr></table><br />';
	
	template_BCP_below();
}



function template_customWindows() {
	global $settings, $txt, $context, $scripturl, $blog;
	
	template_BCP_above();
	template_listControlPanelItems('customWindows');
	template_addForm('customWindows');
	
	echo '
	<table border="0" width="100%" cellspacing="1" cellpadding="0" align="center" class="bordercolor"><tr><td width="100%">
				<table border="0" width="100%" cellspacing="0" cellpadding="4" align="center" id="moveWindows">
					<tr class="catbg">
						<td height="26">
							&nbsp;<img src="'. $settings['images_url'] .'/icons/profile_sm.gif" alt="" align="top" />&nbsp;', $txt['sideWindowOrders'], '
						</td>
					</tr>
					<tr class="windowbg2">
						<td width="100%">
							<table width="100%" border="0" cellspacing="0" cellpadding="4" align="center">';
						
	for ($i = 1; $i <= count($context['blog']['sideWindows']); $i++) {
		if (isset($context['blog']['sideWindows'][$i])) {
			echo '
								<tr class="needsPadding">
									<td width="50%" align="right">'. $txt[$context['blog']['sideWindows'][$i] .'WindowOrder'] .' </td>
									<td width="50%" align="left">';
									
			if ($context['blog']['display_move_window_form'] != $context['blog']['sideWindows'][$i])
				echo 
									'<span class="controlPanelDisplayBox">', !empty($context['blog']['settings'][$context['blog']['sideWindows'][$i] .'WindowOrder']['value']) ? $context['blog']['settings'][$context['blog']['sideWindows'][$i] .'WindowOrder']['value'] : $txt['b24'], '</span> <a href="'. $scripturl .'?action=blogControlPanel;u='. $context['blog']['controlPanelOwner']['id'] .';blog='. $blog .';moveWindow='. $context['blog']['sideWindows'][$i] .';sa=customWindows'. (!empty($_REQUEST['blogStart']) ? ';blogStart='. $_REQUEST['blogStart'] : '') .'#moveWindows" rel="nofollow">'. $txt['b23'] .'</a>';
			else
				windowOrderSelect();
					
			echo '
									</td>
								</tr>';
		}
	}
			
	echo '
							</table>
						</td>
					</tr>
				</table>
	</td></tr></table><br />';
	
	template_BCP_below();
}



function template_blogCategories()
{
	template_BCP_above();
	template_listControlPanelItems('blogCategories');
	template_addForm('blogCategories');
	template_BCP_below();
}

function template_blogLinks()
{
	template_BCP_above();
	template_listControlPanelItems('blogLinks');
	template_addForm('blogLinks');
	template_BCP_below();
}

function template_blogTags()
{
	template_BCP_above();
	template_listControlPanelItems('blogTags');
	template_BCP_below();
}

function template_blogPlugIns()
{
	global $txt, $blog, $context, $settings, $scripturl, $modSettings;
	template_BCP_above();
	echo '
	<table border="0" width="100%" cellspacing="1" cellpadding="0" align="center" class="bordercolor"><tr><td width="100%">
				<table border="0" width="100%" cellspacing="0" cellpadding="4">
					<tr class="catbg">
						<td colspan="4" height="26">
							&nbsp;<img src="'. $settings['images_url'] .'/icons/profile_sm.gif" alt="" align="top" />&nbsp;'. $txt['blog_plugins'] .'
						</td>
					</tr>';
					
	if (!empty($context['blog']['plugins']))
	{
		echo '
					<tr class="windowbg2">
						<td width="100%">
							<table border="0" width="100%" cellspacing="0" cellpadding="4" align="center">
							<form action="'. $scripturl .'?action=blogControlPanel;u='. $context['blog']['controlPanelOwner']['id'] .';blog='. $blog .';sa='. $_REQUEST['sa'] .';sesc='. $context['session_id'] . (!empty($_REQUEST['blogStart']) ? ';blogStart='. $_REQUEST['blogStart'] : '') .'" method="post" accept-charset="', $context['character_set'], '">';
		foreach ($context['blog']['plugins'] as $plugin => $array)
			echo '
								<tr>
									<td colspan="2" width="100%" align="center"><hr size="1" width="100%" class="hrcolor" /></td>
								</tr>
								<tr class="needsPadding">
									<td colspan="2" width="100%" align="center" style="padding-bottom:12px;"><span class="controlPanelSectionHeader">'. $array['name'] .'</span></td>
								</tr>
								<tr class="needsPadding">
									<td colspan="2" width="100%" align="center">
										<label for="'. $plugin .'0"><input type="radio" name="enable_plugin_'. $plugin .'" id="'. $plugin .'0" class="check" value="0"', empty($modSettings['enable_plugin_' . $plugin]) ? ' checked="checked"' : '', ' />&nbsp;'. $txt['b11'] .'</label>&nbsp;&nbsp;
										<label for="'. $plugin .'1"><input type="radio" name="enable_plugin_'. $plugin .'" id="'. $plugin .'1" class="check" value="1"', !empty($modSettings['enable_plugin_' . $plugin]) ? ' checked="checked"' : '', ' />&nbsp;'. $txt['b86'] .'</label>
									</td>
								</tr>';
		echo '
								<tr>
									<td colspan="2" width="100%" align="center"><hr size="1" width="100%" class="hrcolor" /></td>
								</tr>
								<tr class="needsPadding">
									<td colspan="2" width="100%" align="center">
										<input type="hidden" name="savePlugInSettings" />
										<input type="submit" value="'. $txt[10] .'" />
									</td>
								</tr>
							</form>
							</table>
						</td>
					</tr>';
	}
	else
	{
		echo '
					<tr class="windowbg2">
						<td width="100%">'. $txt['no_plugins'] .'</td>
					</tr>';
	}
	echo '
				</table>
	</td></tr></table><br />';
	template_BCP_below();
}

function template_postingRestrictions()
{
	global $context, $scripturl, $blog, $txt, $settings;
	template_BCP_above();
	template_listControlPanelItems('usersAllowedToBlog', 'postingRestrictions');
	template_addForm('usersAllowedToBlog', 'postingRestrictions');
	if (!empty($context['blog']['defaultSettings']['allowedGroups']['options'])) {
		echo '
	<table border="0" width="100%" cellspacing="1" cellpadding="0" align="center" class="bordercolor"><tr><td width="100%">
				<table border="0" width="100%" cellspacing="0" cellpadding="4">
					<tr class="catbg">
						<td colspan="4" height="26">
							&nbsp;<img src="'. $settings['images_url'] .'/icons/profile_sm.gif" alt="" align="top" />&nbsp;'. $txt['groupsAllowedToBlog'] .'
						</td>
					</tr>
					<tr class="windowbg2">
						<td width="100%">
							<table border="0" width="100%" cellspacing="0" cellpadding="4" align="center">
							<form action="'. $scripturl .'?action=blogControlPanel;u='. $context['blog']['controlPanelOwner']['id'] .';blog='. $blog .';sa=postingRestrictions;sesc='. $context['session_id'] . (!empty($_REQUEST['blogStart']) ? ';blogStart='. $_REQUEST['blogStart'] : '') .'" method="post" accept-charset="', $context['character_set'], '">';
		foreach ($context['blog']['defaultSettings']['allowedGroups']['options'] as $id => $option)
			echo '
								<tr class="needsPadding">
									<td width="50%" align="right">'. $option .' </td>
									<td width="50%" align="left">
										<input type="checkbox" name="groupsAllowedToBlog[]"', !empty($context['blog']['settings']['groupsAllowedToBlog']['value']) ? (in_array($id, $context['blog']['settings']['groupsAllowedToBlog']['value']) ? ' checked="checked"' : '') : '', ' value="'. $id .'" />
									</td>
									<td width="30" align="right"></td>
								</tr>';
		echo '
								<tr class="needsPadding">
									<td width="50%" align="right"><i>'. $txt[737] .'</i> </td>
									<td width="50%" align="left">
										<input type="checkbox" onclick="invertAll(this, this.form, \'groupsAllowedToBlog[]\');" class="check" />
									</td>
									<td width="30" align="right"></td>
								</tr>
								<tr class="needsPadding">
									<td colspan="2" width="100%" align="center">
										<input type="hidden" name="saveGroupsAllowedToBlog" value="1" />
										<input type="submit" value="'. $txt[10] .'" />
									</td>
									<td width="30" align="right"><a href="'. $scripturl .'?action=blogHelp'. (!empty($blog) ? ';blog='. $blog : '') .';help=help_groupsATB" onclick="return reqWin(this.href);" class="help" rel="nofollow"><img src="'. $settings['default_theme_url'] .'/images/icons/QuestionIcon.gif" alt="(?)" title="'. $txt['b80'] .'" /></a></td>
								</tr>
							</form>
							</table>
						</td>
					</tr>
				</table>
	</td></tr></table><br />';
	}
	template_BCP_below();
}



function template_adminOnlyOptions()
{
	global $settings, $txt, $scripturl, $context;
	template_BCP_above();
	echo '
	<table border="0" width="100%" cellspacing="1" cellpadding="0" align="center" class="bordercolor"><tr><td width="100%">
				<table border="0" width="100%" cellspacing="0" cellpadding="4" align="center">
					<tr class="catbg">
						<td colspan="4" height="26">
							&nbsp;<img src="'. $settings['images_url'] .'/icons/profile_sm.gif" alt="" align="top" />&nbsp;'. $txt['admin_only_blog_options'] .'
						</td>
					</tr>
					<tr class="windowbg2">
						<td width="100%">
							<table width="100%" border="0" cellspacing="0" cellpadding="4">
								<tr class="needsPadding">
									<td colspan="2" align="center" width="100%">'. $txt['blog_use_to_convert'] .'</td>
								</tr>
								<tr class="needsPadding">
									<form method="post" action="'. $scripturl .'?action=blogControlPanel;u='. $context['blog']['controlPanelOwner']['id'] .';sa=initBlog;sesc='. $context['session_id'] .'">
									<td align="right" width="50%">
										<select name="convertBoard">';
									
	if (!empty($context['non_blog_boards']))
		foreach($context['non_blog_boards'] as $id => $name)
			echo '
											<option value="'. $id .'" style="padding:2px;">'. $name .'</option>';
										
	echo '
										</select>
									</td>
									<td align="left" width="50%"><input type="submit" name="convertBoardToBlog" value="'. $txt['b20'] .'" onclick="return confirm(\'', $txt['confirm_blog_convert'], '\');" /></td>
									</form>
								</tr>
								<tr class="needsPadding">
									<td colspan="2" align="center" width="100%">'. $txt['blog_use_to_revert'] .'</td>
								</tr>
								<tr class="needsPadding">
									<form method="post" action="'. $scripturl .'?action=blogControlPanel;u='. $context['blog']['controlPanelOwner']['id'] .';sa=initBlog;sesc='. $context['session_id'] .'">
									<td align="right" width="50%">
										<select name="revertBoard">';
									
	if (!empty($context['blog_boards']))
		foreach($context['blog_boards'] as $id => $name)
			echo '
											<option value="'. $id .'" style="padding:2px;">'. $name .'</option>';
										
	echo '
										</select>
									</td>
									<td align="left" width="50%"><input type="submit" name="revertBlogToBoard" value="'. $txt['b21'] .'" onclick="return confirm(\'', $txt['confirm_blog_revert'], '\');" /></td>
									</form>
								</tr>
								
								<tr class="needsPadding"><td colspan="2" width="100%"><hr size="1" width="100%" class="hrcolor" /></td></tr>
						
								<form method="post" action="'. $scripturl .'?action=blogControlPanel;u='. $context['blog']['controlPanelOwner']['id'] .';sa=adminOnlyOptions;sesc='. $context['session_id'] . (!empty($_REQUEST['blogStart']) ? ';blogStart='. $_REQUEST['blogStart'] : '') .'" accept-charset="'. $context['character_set'] .'">';
						
	foreach ($context['blog']['admin_settings'] as $setting => $array)
		template_displayFormField($setting, $array, 'admin_settings');
				
	echo '
								<tr class="needsPadding">
									<td colspan="2" align="center" width="100%">
										<input type="hidden" name="saveAdminBlogSettings" value="1" />
										<input type="submit" value="'. $txt[10] .'" />
									</td>
								</tr>
								</form>
							</table>
						</td>
					</tr>
				</table>
	</td></tr></table><br />';
	template_BCP_below();
}









function template_popupWindowPreview()
{
	global $context, $settings, $options, $txt;

	// Since this is a popup of its own we need to start the html, etc.
	echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"', $context['right_to_left'] ? ' dir="rtl"' : '', '>
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=', $context['character_set'], '" />
		<title>', $context['page_title'], '</title>
		<link rel="stylesheet" type="text/css" href="', $settings['theme_url'], '/style.css" />
		<style type="text/css">';

	// Internet Explorer 4/5 and Opera 6 just don't do font sizes properly. (they are bigger...)
	if ($context['browser']['needs_size_fix'])
		echo '
			@import(', $settings['default_theme_url'], '/fonts-compat.css);';

	echo '
		</style>
	</head>
	<body style="margin: 2ex;">
		<div style="text-align:center;">';
			
	if (!empty($context['previewThisWindow']))
		template_sideWindow($context['previewThisWindow']);
	else
		echo $txt['error_no_such_window'];
			
	echo '
			<br /><br />
			<a href="javascript:self.close();">', $txt[1006], '</a>
		</div>
	</body>
</html>';
}


function template_extraBelowSideWindows()
{
	global $context, $modSettings, $blog, $scripturl;
	if (!empty($modSettings['allowMyBlogLog']) && !empty($context['blog']['settings']['enableMBLStatTracking']) && !empty($context['blog']['settings']['myBlogLogSiteID']))
		echo '
		<script type="text/javascript" src="http://track.mybloglog.com/js/jsserv.php?mblID='. $context['blog']['settings']['myBlogLogSiteID'] .'"></script>';
		
	if (!empty($context['blog']['extra_sidebar_buttons']))
		foreach ($context['blog']['extra_sidebar_buttons'] as $key => $button)
		{
			if (!empty($key))
				echo '<br />';
			echo '<br />' . $button;
		}
}





?>