<?php

if (!defined('SMF'))
	die('Hacking attempt...');
	
/*

	Blog Community 2.0.2 Beta
	
	Blog Community was developed by Charles Hill for use in conjunction with Simple Machines Forum.  The 
	code of Blog Community is not to be redistributed or used for any purpose other than what is intended 
	without express written permission from the developer.  All rights are reserved by the developer.
	
	This software is distributed in the hope that it is and will be useful, but WITHOUT ANY WARRANTIES; without even 
	any implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
	
*/

/*
		Plug-in Slots:
			1 ... In template_showArticles() after the article "options" and "share" in Blog.template.php
			2 ... In template_showArticles() after the comment "options" and unapproved alert icon in Blog.template.php
			3 ... At the top of loadSideWindows() in Sources/Blog.php
			4 ... In loadBlogIndexSideWindows() after $context['blog']['blogIndexSideWindows'] and $windowOrders are set in Sources/Blog.php
			5 ... In blogControlPanel2($memID = null) before $context['current_subMenu'] is determined in Sources/Blog.php
			6 ... At the end of prepareDefaultBlogSettings($memID = null) in Sources/BlogSettings.php
			7 ... Near the top of Blog() in Sources/Blog.php
			
		NOTE:
			- plugins settings use $modSettings (settings table)
*/

function prepareBlogPlugIns()
{
	global $context;
	$context['blog']['plugin_slots'] = array();
	$context['blog']['plugins'] = array();
	// only need to set the plugin_settings up when viewing the plugins page
	if (!empty($context['viewing_plugins_page']))
	{
		// settings use the same attributes as the settings arrays from BlogSettings.php
		/*
		
		Example:
		
		$context['blog']['plugins']['moods_on_articles']['settings'] = array(
			'enable_plugin_moods_on_articles' => array(
				'type' => 'check',
				'value' => 0,
			),
		);
		
		*/
		$context['blog']['plugin_settings'] = array();
		// now we combine all the plugins' settings into one array
		// it's done this way to increase compatibility and stability
		if (!empty($context['blog']['plugins']))
			foreach ($context['blog']['plugins'] as $plugin => $array)
				array_merge($context['blog']['plugin_settings'], $array['settings']);
	}
}


?>