<?php
/*******************************************************************************
	This is a simplified script to add settings into SMF.

	ATTENTION: If you are trying to INSTALL this package, please access
	it directly, with a URL like the following:
		http://www.yourdomain.com/forum/add_settings.php (or similar)

	This script can be used to add new settings into the database for use
	with SMF's $modSettings array.  It is meant to be run either from the
	package manager or directly by URL.

*******************************************************************************/

// If SSI.php is in the same place as this file, and SMF isn't defined, this is being run standalone.
if (file_exists(dirname(__FILE__) . '/SSI.php') && !defined('SMF'))
	require_once(dirname(__FILE__) . '/SSI.php');
// Hmm... no SSI.php and no SMF?
elseif (!defined('SMF'))
	die('<b>Error:</b> Cannot install - please verify you put this in the same place as SMF\'s index.php.');


	global $db_prefix, $scripturl;
	// creates the blog categories table
	$result = db_query("
	CREATE TABLE IF NOT EXISTS {$db_prefix}blog_categories(
		categoryID int(10) NOT NULL auto_increment,
		memberID int(10) NOT NULL default '0',
		boardID int(10) NOT NULL default '0',
		name varchar(100) NOT NULL,
		catOrder int(10) NOT NULL default '0',
		total int(10) unsigned NOT NULL default '0',
		PRIMARY KEY (categoryID))", __FILE__, __LINE__);
		
	// creates the blog settings table
	$result2 = db_query("
	CREATE TABLE IF NOT EXISTS {$db_prefix}blog_settings(
		memberID int(10) NOT NULL default '0',
		boardID int(10) NOT NULL default '0',
		variable text NOT NULL,
		value text NOT NULL)", __FILE__, __LINE__);
		
	// creates the blog links table
	$result3 = db_query("
	CREATE TABLE IF NOT EXISTS {$db_prefix}blog_links(
		linkID int(10) NOT NULL auto_increment,
		memberID int(10) NOT NULL default '0',
		boardID int(10) NOT NULL default '0',
		linkOrder int(10) NOT NULL default '0',
		linkName text NOT NULL,
		url text NOT NULL,
		title text NOT NULL,
		PRIMARY KEY (linkID))", __FILE__, __LINE__);
		
	// creates the blog tags table
	$result4 = db_query("
	CREATE TABLE IF NOT EXISTS {$db_prefix}blog_tags(
		tagID int(10) NOT NULL auto_increment,
		memberID int(10) NOT NULL default '0',
		boardID int(10) NOT NULL default '0',
		numTopics int(10) NOT NULL default '0',
		tag text NOT NULL,
		PRIMARY KEY (tagID))", __FILE__, __LINE__);
		
	// creates the blog custom windows table
	$result5 = db_query("
	CREATE TABLE IF NOT EXISTS {$db_prefix}blog_custom_windows(
		windowID int(10) NOT NULL auto_increment,
		memberID int(10) NOT NULL default '0',
		boardID int(10) NOT NULL default '0',
		content text NOT NULL,
		title text NOT NULL,
		PRIMARY KEY (windowID))", __FILE__, __LINE__);
		
	// creates the blog verification table
	$result6 = db_query("
	CREATE TABLE IF NOT EXISTS {$db_prefix}blog_verification(
		ver_code int(10) NOT NULL default '0',
		memberID int(10) NOT NULL default '0',
		boardID int(10) NOT NULL default '0',
		variable text NOT NULL)", __FILE__, __LINE__);
		
	// Inserts into the settings table
	db_query("
	INSERT IGNORE INTO {$db_prefix}settings 
		(variable, value) 
	VALUES 
		('blogMode', '0'),
		('category_for_blogs', '0'),
		('hideBlogBoards', '1'),
		('max_num_blogs', '0'), 
		('blogBoard', '0'),
		('excludeBlogsForumTotals', '1'),
		('hideBlogPostsFromForumRecentPosts', '1'),
		('allowBlogCatalog', '0'),
		('allowMyBlogLog', '0'),
		('toggle_all_layerless', '0'),
		('maxIndexArticleList', '20'),
		('maxIndexCommentList', '10'),
		('sortBlogIndexByViews', '1'),
		('showAvatarsOnBlogIndex', '1'),
		('showRSSFeedsOnBlogIndex', '0'),
		('maxIndexOnBlogIndex', '20'),
		('blog_index_side_bar', '0'),
		('blog_index_without_layers', '0'),
		('blog_index_width', '65%'),
		('blog_index_alignment', 'center'),
		('default_meta_keywords', ''),
		('defaultAllowedGroups', '-1,0,2'),
		('disable_guest_captcha', '0'),
		('captcha_blog_only', '1'),
		('enable_plugin_slot_1', '0'),
		('enable_plugin_slot_2', '0'),
		('enable_plugin_slot_3', '0'),
		('enable_plugin_slot_4', '0'),
		('enableGlobalMostRecentWindow', '0'),
		('enableGlobalTagsWindow', '0'),
		('blog_index_side_bar', '0'),
		('hide_portal_blocks', '0')", __FILE__, __LINE__);
	
	$update_tables = array(
		'topics' => array(
			array('name' => 'blogTags', 'insert' => 'blogTags text NOT NULL'),
			array('name' => 'categoryID', 'insert' => 'categoryID int(10) unsigned NOT NULL default \'0\''),
			array('name' => 'year', 'insert' => 'year int(4) unsigned NOT NULL default \'0\''),
			array('name' => 'month', 'insert' => 'month int(2) unsigned NOT NULL default \'0\''),
		),
		'blog_settings' => array(
			array('name' => 'boardID', 'insert' => 'boardID int(10) unsigned NOT NULL default \'0\''),
		),
		'blog_links' => array(
			array('name' => 'linkOrder', 'insert' => 'linkOrder int(10) unsigned NOT NULL default \'0\''),
		),
		'blog_categories' => array(
			array('name' => 'boardID', 'insert' => 'boardID int(10) unsigned NOT NULL default \'0\''),
			array('name' => 'memberID', 'insert' => 'memberID int(10) unsigned NOT NULL default \'0\''),
		),
		'boards' => array(
			array('name' => 'blog_owner', 'insert' => 'blog_owner int(10) unsigned NOT NULL default \'0\''),
			array('name' => 'blogViews', 'insert' => 'blogViews int(10) unsigned NOT NULL default \'0\''),
			array('name' => 'blog_board', 'insert' => 'blog_board tinyint(1) unsigned NOT NULL default \'0\''),
			array('name' => 'timeCreated', 'insert' => 'timeCreated int(10) unsigned NOT NULL default \'0\''),
		),
		'messages' => array(
			array('name' => 'comment_approved', 'insert' => 'comment_approved tinyint(1) unsigned NOT NULL default \'0\''),
		),
	);
	
	// update all the tables with new columns
	foreach ($update_tables as $table => $new_columns)
	{
		foreach ($new_columns as $column)
		{
			$rows = mysql_num_rows(db_query("SHOW COLUMNS FROM {$db_prefix}$table LIKE '$column[name]'", __FILE__, __LINE__));
			if ($rows == 0)
			{
				// Add $new_column to $table
				db_query("
					ALTER TABLE {$db_prefix}$table 
						ADD $column[insert]", __FILE__, __LINE__);
			}
		}
	}

		 echo '
	<span><b>Your settings have been entered into the database!</b><br />
	<b>Blog Community</b> was successfully installed.  Click <a href="'. $scripturl .'?action=blogControlPanel">here</a> to view your Blog Control Panel.';


if (($result == false) || ($result2 == false) || ($result3 == false) || ($result4 == false) || ($result5 == false) || ($result6 == false))
	echo '<b>Error:</b> Database modifications failed!';

?>